Package: clustermq
Title: Evaluate Function Calls on HPC Schedulers (SLURM, LSF, SGE, GCS,
        OCS, PBS, Torque)
Version: 0.10.1
Authors@R: c(
    person('Michael', 'Schubert', email='mschu.dev@gmail.com',
           role = c('aut', 'cre', 'cph'),
           comment = c(ORCID='0000-0002-6862-5221')),
    person('ZeroMQ authors',
           role = c('aut', 'cph'),
           comment = "source files in 'src/libzmq' and 'src/cppzmq'"))
Maintainer: Michael Schubert <mschu.dev@gmail.com>
Description: Evaluate arbitrary function calls using workers on HPC schedulers
    in single line of code. All processing is done on the network without
    accessing the file system. Remote schedulers are supported via SSH.
URL: https://mschubert.github.io/clustermq/
BugReports: https://github.com/mschubert/clustermq/issues
SystemRequirements: ZeroMQ (libzmq) >= 4.3.0 (optional; otherwise
        bundled)
Depends: R (>= 3.6.2)
LinkingTo: Rcpp
Imports: methods, globals, progress, R6, Rcpp, utils
License: Apache License (== 2.0) | file LICENSE
Encoding: UTF-8
Suggests: BiocParallel, callr, devtools, foreach, iterators, knitr,
        parallel, rmarkdown, roxygen2 (>= 5.0.0), testthat, tools
VignetteBuilder: knitr
RoxygenNote: 7.3.3
NeedsCompilation: yes
Packaged: 2026-06-03 16:37:59 UTC; mschu
Author: Michael Schubert [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0002-6862-5221>),
  ZeroMQ authors [aut, cph] (source files in 'src/libzmq' and
    'src/cppzmq')
Repository: CRAN
Date/Publication: 2026-06-04 05:11:23 UTC
Built: R 4.5.2; aarch64-apple-darwin20; 2026-06-04 08:46:00 UTC; unix
Archs: clustermq.so.dSYM

ClusterMQ: send R function calls as cluster jobs
================================================

[![CRAN version](https://www.r-pkg.org/badges/version/clustermq)](https://cran.r-project.org/package=clustermq)
[![Build Status](https://github.com/mschubert/clustermq/actions/workflows/check-standard.yaml/badge.svg)](https://github.com/mschubert/clustermq/actions)
[![CRAN downloads](https://cranlogs.r-pkg.org/badges/clustermq)](https://cran.r-project.org/package=clustermq)
[![DOI](https://zenodo.org/badge/DOI/10.1093/bioinformatics/btz284.svg)](https://doi.org/10.1093/bioinformatics/btz284)

This package will allow you to send function calls as jobs on a computing
cluster with a minimal interface provided by the `Q` function:

```r
# install the package if you haven't done so yet
Sys.setenv(CLUSTERMQ_AUTO_LIBZMQ=1)
install.packages('clustermq')

# queue a function call on your scheduler
library(clustermq)
fx = function(x) x * 2
Q(fx, x=1:3, n_jobs=1)
# list(2,4,6)
```

Computations are done [entirely on the network](https://zeromq.org/)
and without any temporary files on network-mounted storage, so there is no
strain on the file system apart from starting up R once per job. All
calculations are load-balanced, i.e. workers that get their jobs done faster
will also receive more function calls to work on. This is especially useful if
not all calls return after the same time, or one worker has a high load.

Browse the vignettes here:

* [User Guide](https://mschubert.github.io/clustermq/articles/userguide.html)
* [Technical Documentation](https://mschubert.github.io/clustermq/articles/technicaldocs.html)
* [FAQ](https://mschubert.github.io/clustermq/articles/faq.html)

Schedulers
----------

An HPC cluster's scheduler ensures that computing jobs are distributed to
available worker nodes. Hence, this is what clustermq interfaces with in order
to do computations.

We currently support the [following
schedulers](https://mschubert.github.io/clustermq/articles/userguide.html#configuration)
(either locally or via SSH):

* [Multiprocess](https://mschubert.github.io/clustermq/articles/userguide.html#local-parallelization) -
  *test your calls and parallelize on cores using* `options(clustermq.scheduler="multiprocess")`
* [SLURM](https://mschubert.github.io/clustermq/articles/userguide.html#slurm) - *should work without setup*
* [LSF](https://mschubert.github.io/clustermq/articles/userguide.html#lsf) - *should work without setup*
* [SGE](https://mschubert.github.io/clustermq/articles/userguide.html#sge) - *may require configuration*
* [GCS](https://mschubert.github.io/clustermq/articles/userguide.html#gcs)/[OCS](https://mschubert.github.io/clustermq/articles/userguide.html#ocs) - *needs* `options(clustermq.scheduler="GCS"/"OCS")`
* [PBS](https://mschubert.github.io/clustermq/articles/userguide.html#pbs)/[Torque](https://mschubert.github.io/clustermq/articles/userguide.html#torque) - *needs* `options(clustermq.scheduler="PBS"/"Torque")`
* via [SSH](https://mschubert.github.io/clustermq/articles/userguide.html#ssh-connector) -
*needs* `options(clustermq.scheduler="ssh", clustermq.ssh.host=<yourhost>)`

> [!TIP]
> Follow the links above to configure your scheduler in case it is not working
> out of the box and check the
> [FAQ](https://mschubert.github.io/clustermq/articles/faq.html) if
> your job submission errors or gets stuck

Usage
-----

The most common arguments for `Q` are:

 * `fun` - The function to call. This needs to be self-sufficient (because it
        will not have access to the `master` environment)
 * `...` - All iterated arguments passed to the function. If there is more than
        one, all of them need to be named
 * `const` - A named list of non-iterated arguments passed to `fun`
 * `export` - A named list of objects to export to the worker environment

The documentation for other arguments can be accessed by typing `?Q`. Examples
of using `const` and `export` would be:

```r
# adding a constant argument
fx = function(x, y) x * 2 + y
Q(fx, x=1:3, const=list(y=10), n_jobs=1)

# exporting an object to workers
fx = function(x) x * 2 + y
Q(fx, x=1:3, export=list(y=10), n_jobs=1)
```

We can also use `clustermq` as a parallel backend in
[`foreach`](https://cran.r-project.org/package=foreach) or
[`BiocParallel`](https://bioconductor.org/packages/release/bioc/html/BiocParallel.html):

```r
# using foreach
library(foreach)
register_dopar_cmq(n_jobs=2, memory=1024) # see `?workers` for arguments
foreach(i=1:3) %dopar% sqrt(i) # this will be executed as jobs

# using BiocParallel
library(BiocParallel)
register(DoparParam()) # after register_dopar_cmq(...)
bplapply(1:3, sqrt)
```

More examples are available in [the
User Guide](https://mschubert.github.io/clustermq/articles/userguide.html).

Comparison to other packages
----------------------------

There are some packages that provide high-level parallelization of R function calls
on a computing cluster. We compared `clustermq` to `BatchJobs` and `batchtools` for
processing many short-running jobs, and found it to have approximately 1000x less
overhead cost.

![Overhead comparison](http://image.ibb.co/cRgYNR/plot.png)

In short, use `clustermq` if you want:

* a one-line solution to run cluster jobs with minimal setup
* access cluster functions from your local Rstudio via SSH
* fast processing of many function calls without network storage I/O

Use [`batchtools`](https://github.com/mlr-org/batchtools) if you:

* want to use a mature and well-tested package
* don't mind that arguments to every call are written to/read from disc
* don't mind there's no load-balancing at run-time

Use [Snakemake](https://snakemake.readthedocs.io/en/latest/) or
[`targets`](https://github.com/ropensci/targets) if:

* you want to design and run a workflow on HPC

Don't use [`batch`](https://cran.r-project.org/package=batch)
(last updated 2013) or [`BatchJobs`](https://github.com/tudo-r/BatchJobs)
(issues with SQLite on network-mounted storage).

Contributing
------------

Contributions are welcome and they come in many different forms, shapes, and
sizes. These include, but are not limited to:

* **Questions**: Ask on the [Github
  Discussions](https://github.com/mschubert/clustermq/discussions) board. If
  you are an advanced user, please also consider answering questions there.
* **Bug reports**: [File an issue](https://github.com/mschubert/clustermq/issues)
  if something does not work as expected. Be sure to
  include a self-contained [Minimal Reproducible
  Example](https://stackoverflow.com/help/minimal-reproducible-example) and set
  `log_worker=TRUE`.
* **Code contributions**: Have a look at the [`good first
  issue`](https://github.com/mschubert/clustermq/issues?q=is%3Aissue+is%3Aopen+label%3A%22good+first+issue%22)
  tag. Please discuss anything more complicated before putting a lot of work
  in, I'm happy to help you get started.

> [!TIP]
> Check the
> [User Guide](https://mschubert.github.io/clustermq/articles/userguide.html) and the
> [FAQ](https://mschubert.github.io/clustermq/articles/faq.html) first, maybe
> your query is already answered there

Citation
--------

This project is part of my academic work, for which I will be evaluated on
citations. If you like me to be able to continue working on research support
tools like `clustermq`, please cite the article when using it for publications:

> M Schubert. clustermq enables efficient parallelisation of genomic analyses.
> *Bioinformatics* (2019).
> [doi:10.1093/bioinformatics/btz284](https://doi.org/10.1093/bioinformatics/btz284)

## ----echo=FALSE, results="hide"-----------------------------------------------
knitr::opts_chunk$set(
    cache = FALSE,
    echo = TRUE,
    collapse = TRUE,
    comment = "#>"
)
options(clustermq.scheduler = "local", rmarkdown.html_vignette.check_title = FALSE)
suppressPackageStartupMessages(library(clustermq))

## ----eval=FALSE---------------------------------------------------------------
# > clustermq::Q(identity, x=42, n_jobs=1)
# Submitting 1 worker jobs (ID: cmq8480) ...
# Running 1 calculations (5 objs/19.4 Kb common; 1 calls/chunk) ...

## ----eval=FALSE---------------------------------------------------------------
# options(clustermq.scheduler = "ssh",
#         clustermq.ssh.log = "~/ssh_proxy.log")
# Q(identity, x=1, n_jobs=1)

## ----eval=FALSE---------------------------------------------------------------
# options(clustermq.ssh.timeout = 30) # in seconds

## ----echo=FALSE, results="hide"-----------------------------------------------
knitr::opts_chunk$set(
    cache = FALSE,
    echo = TRUE,
    collapse = TRUE,
    comment = "#>"
)
options(clustermq.scheduler = "local")
suppressPackageStartupMessages(library(clustermq))

## ----eval=FALSE---------------------------------------------------------------
# # start up a pool of three workers using the default scheduler
# w = workers(n_jobs=3)
# 
# # if we make an unclean exit for whatever reason, clean up the jobs
# on.exit(w$cleanup())

## ----eval=FALSE---------------------------------------------------------------
# msg = w$recv() # this will block until a worker is ready

## ----eval=FALSE---------------------------------------------------------------
# w$send_eval(expression, ...)

## ----eval=FALSE---------------------------------------------------------------
# w$send(clustermq:::work_chunk(chunk, fun, const, rettype, common_seed),
#        chunk = chunk(iter, submit_index))

## ----eval=FALSE---------------------------------------------------------------
# w$env(object=value, ...)

## ----eval=FALSE---------------------------------------------------------------
# w = workers(3)
# on.exit(w$cleanup())
# w$env(...)
# 
# while (we have new work to send || jobs pending) {
#     res = w$recv() # the result of the call, or NULL for a new worker
#     # handle result
# 
#     if (more work)
#         call_ref = w$send_eval(expression, ...) # call_ref tracks request identity
#     else
#         w$send_shutdown()
# }

## ----eval=FALSE---------------------------------------------------------------
# R_tryEvalSilent(cmd, env, &err);

## ----echo=FALSE, results="hide"-----------------------------------------------
knitr::opts_chunk$set(
    cache = FALSE,
    echo = TRUE,
    collapse = TRUE,
    comment = "#>"
)
options(clustermq.scheduler = "local")
suppressPackageStartupMessages(library(clustermq))

## ----eval=FALSE---------------------------------------------------------------
# # Recommended:
# #   If your system has `libzmq` installed but you want to enable the worker
# #   crash monitor, set the environment variable below to use the bundled
# #   `libzmq` library with the required feature (`-DZMQ_BUILD_DRAFT_API=1`):
# Sys.setenv(CLUSTERMQ_AUTO_LIBZMQ=1)
# install.packages("clustermq")

## ----eval=FALSE---------------------------------------------------------------
# if (!requireNamespace("remotes", quietly=TRUE))
#     install.packages("remotes")
# Sys.setenv(CLUSTERMQ_AUTO_LIBZMQ=1)
# remotes::install_github("mschubert/clustermq")
# # remotes::install_github("mschubert/clustermq@develop") # dev version

## ----eval=FALSE---------------------------------------------------------------
# # If this is set to 'LOCAL' or 'SSH' you will get the following error:
# #  Expected PROXY_READY, received ‘PROXY_ERROR: Remote SSH QSys is not allowed’
# options(
#     clustermq.scheduler = "multiprocess" # or multicore, LSF, SGE, Slurm etc.
# )

## ----eval=FALSE---------------------------------------------------------------
# options(
#     clustermq.scheduler = "ssh",
#     clustermq.ssh.host = "user@host", # use your user and host, obviously
#     clustermq.ssh.log = "~/cmq_ssh.log" # log for easier debugging
# )

## -----------------------------------------------------------------------------
fx = function(x) x * 2
Q(fx, x=1:3, n_jobs=1)

## -----------------------------------------------------------------------------
fx = function(x, y) x * 2 + y
Q(fx, x=1:3, const=list(y=10), n_jobs=1)

## -----------------------------------------------------------------------------
fx = function(x) x * 2 + y
Q(fx, x=1:3, export=list(y=10), n_jobs=1)

## -----------------------------------------------------------------------------
f1 = function(x) splitIndices(x, 3)
# Q(f1, x=5, n_jobs=1)
# (Error #1) could not find function "splitIndices"

Q(f1, x=3, n_jobs=1, pkgs="parallel")

f2 = function(x) parallel::splitIndices(x, 3)
Q(f2, x=8, n_jobs=1)

## -----------------------------------------------------------------------------
library(foreach)
foreach(i=1:3) %do% sqrt(i)

## -----------------------------------------------------------------------------
# set up the scheduler first, otherwise this will run sequentially

# this accepts same arguments as `Q`
# the number of jobs is ignored here since we're using the LOCAL scheduler
clustermq::register_dopar_cmq(n_jobs=2, memory=1024)

# this will be executed as jobs
foreach(i=1:3) %dopar% sqrt(i)

## -----------------------------------------------------------------------------
library(BiocParallel)

# the number of jobs is ignored here since we're using the LOCAL scheduler
clustermq::register_dopar_cmq(n_jobs=2, memory=1024)
register(DoparParam())
bplapply(1:3, sqrt)

## ----eval=FALSE---------------------------------------------------------------
# Q(..., log_worker=TRUE)

## ----eval=FALSE---------------------------------------------------------------
# Q(..., template=list(log_file = <yourlog>))

## ----eval=FALSE---------------------------------------------------------------
# Q(..., template=list(bashenv="my environment name"))

## ----eval=FALSE---------------------------------------------------------------
# options(
#     clustermq.defaults = list(bashenv="my default env")
# )

## ----eval=FALSE---------------------------------------------------------------
# options(
#     clustermq.scheduler = "lsf",
#     clustermq.template = "/path/to/file/below" # if using your own template
# )

## ----eval=FALSE---------------------------------------------------------------
# options(
#     clustermq.scheduler = "gcs",
#     clustermq.template = "/path/to/file/below" # if using your own template
# )

## ----eval=FALSE---------------------------------------------------------------
# options(
#     clustermq.scheduler = "ocs",
#     clustermq.template = "/path/to/file/below" # if using your own template
# )

## ----eval=FALSE---------------------------------------------------------------
# options(
#     clustermq.scheduler = "sge",
#     clustermq.template = "/path/to/file/below" # if using your own template
# )

## ----eval=FALSE---------------------------------------------------------------
# options(
#     clustermq.scheduler = "slurm",
#     clustermq.template = "/path/to/file/below" # if using your own template
# )

## ----eval=FALSE---------------------------------------------------------------
# options(
#     clustermq.scheduler = "pbs",
#     clustermq.template = "/path/to/file/below" # if using your own template
# )

## ----eval=FALSE---------------------------------------------------------------
# options(
#     clustermq.scheduler = "Torque",
#     clustermq.template = "/path/to/file/below" # if using your own template
# )

## ----eval=FALSE---------------------------------------------------------------
# options(
#     clustermq.scheduler = "ssh",
#     clustermq.ssh.host = "myhost", # set this up in your local ~/.ssh/config
#     clustermq.ssh.log = "~/ssh_proxy.log",     # log file on your HPC
#     clustermq.ssh.timeout = 30,    # if changing default connection timeout
#     clustermq.template = "/path/to/file/below" # if using your own template
# )

#' Function to check arguments with which Q() is called
#'
#' @param fun    A function to call
#' @param iter   Objects to be iterated in each function call
#' @param const  A list of constant arguments passed to each function call
#' @return       Processed iterated argument list if 'iter' is a list
#' @keywords     internal
check_args = function(fun, iter, const=list()) {
    if (!is.list(iter) || length(iter) == 0)
        stop("'iter' needs to be a list with at least one element")

    # check function and arguments provided
    funargs = formals(fun)
    required = names(funargs)[unlist(lapply(funargs, function(f) class(f)=='name'))]
    required = setdiff(required, "...")

    if (length(iter) == 1 && length(required) == 1 && is.null(names(iter)))
        names(iter) = required

    provided = names(c(iter, const))

    sdiff = unlist(setdiff(required, provided))
    if (length(sdiff) > 1)
        stop(paste("If more than one argument, all must be named:",
                   paste(sdiff, collapse=" ")))

    sdiff = unlist(setdiff(provided, names(funargs)))
    if (length(sdiff) > 0 && ! '...' %in% names(funargs))
        stop(paste("Argument provided but not accepted by function:",
                   paste(sdiff, collapse=" ")))

    dups = duplicated(provided)
    if (any(dups))
        stop(paste("Argument duplicated:", paste(provided[[dups]], collapse=" ")))

    if (!is.data.frame(iter)) {
        df = data.frame(..placeholder.. = seq_along(iter[[1]]))
        for (field in names(iter))
            df[[field]] = iter[[field]]
        df$..placeholder.. = NULL
        df
    }
}

context("check_args")

test_that("required args are provided", {
    f1 = function(x) x
    # x is provided
    expect_is(check_args(f1, iter=list(x=1)), "data.frame")
    expect_error(check_args(f1, iter=list(y=1)))

    # don't allow empty iter argument
    expect_error(check_args(f1, iter=list()))
    expect_error(check_args(f1, const=list(x=1)))
})

test_that("no superfluous args unless function takes `...`", {
    f1 = function(x) x
    expect_error(check_args(f1, iter=list(x=1, y=1)))
    expect_error(check_args(f1, iter=list(x=1), const=list(y=1)))

    f2 = function(x, ...) x
    expect_is(check_args(f2, iter=list(x=1, y=1)), "data.frame")
    expect_is(check_args(f2, iter=list(x=1), const=list(y=1)), "data.frame")
})

test_that("allow 1 non-optional unnamed arg", {
    f1 = function(x) x
    f2 = function(x, y=1) x+y
    f3 = function(x, y) x+y

    # allow 1 unnamed arg, but not wrong name
    expect_is(check_args(f1, iter=list(1)), "data.frame")
    expect_is(check_args(f2, iter=list(1)), "data.frame")
    expect_error(check_args(f3, iter=list(1)))
})

#' Function to process a chunk of calls
#'
#' Each chunk comes encapsulated in a data.frame
#'
#' @param df           A data.frame with call IDs as rownames and arguments as columns
#' @param fun          The function to call
#' @param const        Constant arguments passed to each call
#' @param rettype      Return type of function
#' @param common_seed  A seed offset common to all function calls
#' @param progress     Logical indicated whether to display a progress bar
#' @return             A list of call results (or try-error if they failed)
#' @keywords internal
work_chunk = function(df, fun, const=list(), rettype="list",
                      common_seed=NULL, progress=FALSE) {
    context = new.env()
    context$warnings = list()
    context$errors = list()
    if (progress) {
        pb = progress::progress_bar$new(total = nrow(df),
                                        format = "[:bar] :percent eta: :eta")
        pb$tick(0)
    }

    fwrap = function(..., ` id `, ` seed `=NA) {
        chr_id = as.character(` id `)
        if (!is.na(` seed `))
            set.seed(` seed `)

        result = withCallingHandlers(
            withRestarts(
                do.call(fun, c(list(...), const)),
                muffleStop = function(e) if (rettype == "list") structure(e, class="error")
            ),
            warning = function(w) {
                wmsg = paste0("(#", chr_id, ") ", conditionMessage(w))
                context$warnings[[chr_id]] = c(context$warnings[[chr_id]], wmsg)
                invokeRestart("muffleWarning")
            },
            error = function(e) {
                emsg = paste0("(Error #", chr_id, ") ", conditionMessage(e))
                if (!is.na(` seed `)) {
                    cur_state = sample(1:100)
                    set.seed(` seed `)
                    prev_state = sample(1:100)
                    if (! all(cur_state == prev_state))
                        emsg = paste0(emsg, " [seed: ", ` seed `, "]")
                }
                context$errors[[chr_id]] = emsg
                invokeRestart("muffleStop", emsg)
            }
        )

        if (progress)
            pb$tick()
        result
    }

    if (is.null(df$` id `))
        df$` id ` = seq_along(df[[1]])

    if (!is.null(common_seed))
        df$` seed ` = as.integer((df$` id ` + common_seed - 1) %% .Machine$integer.max)

    re = stats::setNames(.mapply(fwrap, df, NULL), df$` id `)
    if (rettype != "list")
        re = unlist(re)
    list(result = re, warnings = context$warnings, errors = context$errors)
}

context("work_chunk")

df = structure(row.names=c(NA, -3), class="data.frame", .Data=list(
    a = 1:3,
    b = as.list(letters[1:3]),
    c = setNames(as.list(3:1), letters[1:3])
))

test_that("data types and arg names", {
    fx = function(c, a, b) a + c
    expect_equal(work_chunk(df, fx)$result,
                 setNames(as.list(rep(4,3)), rownames(df)))

    expect_equal(work_chunk(df, fx, rettype="numeric")$result,
                 setNames(rep(4,3), rownames(df)))
})

test_that("check call classes", {
    df2 = df
    df2$a = list(matrix(1:4, nrow=2))
    fx = function(...) sapply(list(...), class)

    re = sapply(colnames(df2), function(i) class(df2[[1,i]]))
    expect_equal(work_chunk(df2, fx)$result, setNames(rep(list(re), 3), c(1:3)))
})

test_that("do not unlist matrix in data.frame", {
    elm = structure(1:4, .Dim = c(2,2), .Dimnames=list(c("r1","r2"), c("c1","c2")))
    df2 = structure(list(expr = structure(list(expr = elm))))

    fx = function(...) list(...)
    expect_equal(work_chunk(df2, fx)$result$'1', list(expr=elm))
})

test_that("warning and error handling", {
    fx = function(a, ...) {
        if (a %% 3 == 0)
            warning("warning")
        if (a %% 2 == 0)
            stop("error")
        a
    }

    re = work_chunk(data.frame(a=1:6), fx)
    expect_equal(sapply(re$result, class) == "error",
                 setNames(rep(c(FALSE,TRUE), 3), 1:6))
    expect_equal(c(1,3,5), unname(unlist(re$result[c(1,3,5)])))
    expect_equal(c(1,3,5), as.integer(names(re$result[c(1,3,5)])))
    expect_equal(length(re$warnings), 2)
    expect_true(grepl("3", re$warnings[[1]]))
    expect_true(grepl("warning", re$warnings[[1]]))
    expect_true(grepl("6", re$warnings[[2]]))
    expect_true(grepl("warning", re$warnings[[2]]))
})

test_that("call can have multiple warnings", {
    fx = function(a) {
        if (a == 1) {
            warning("warning 1")
            warning("warning 2")
        }
    }
    re = work_chunk(data.frame(a=1:2), fx)
    expect_equal(length(re$warnings[['1']]), 2)
})

test_that("const args", {
    fx = function(a, ..., x=23) a + x

    re = work_chunk(df, fx, const=list(x=5))$result
    expect_equal(re, setNames(as.list(df$a + 5), 1:3))
})

test_that("seed reproducibility", {
    fx = function(a, ...) sample(1:1000, 1)

    # seed should be set by common + df row name
    expect_equal(work_chunk(df[1:2,], fx, common_seed=123)$result$'2',
                 work_chunk(df[2:3,], fx, common_seed=123)$result$'2')
})

test_that("env separation", {
    seed = 123
    fx = function(x, common_seed=seed) {
        fun = function(x) stop("overwrite function")
        df = data.frame()
        common_seed
    }
    df2 = data.frame(x=1:5)
    expect_equal(work_chunk(df2, fx)$result, setNames(rep(list(seed), 5), 1:5))
})

#' Queue function calls defined by rows in a data.frame
#'
#' @param df  data.frame with iterated arguments
#' @inheritParams Q
#' @export
#'
#' @examples
#' \dontrun{
#' # Run a simple multiplication for data frame columns x and y on a worker node
#' fx = function (x, y) x * y
#' df = data.frame(x = 5, y = 10)
#' Q_rows(df, fx, job_size = 1)
#' # [1] 50
#'
#' # Q_rows also matches the names of a data frame with the function arguments
#' fx = function (x, y) x - y
#' df = data.frame(y = 5, x = 10)
#' Q_rows(df, fx, job_size = 1)
#' # [1] 5
#' }
Q_rows = function(df, fun, const=list(), export=list(), pkgs=c(), seed=128965,
        memory=NULL, template=list(), n_jobs=NULL, job_size=NULL,
        rettype="list", fail_on_error=TRUE, workers=NULL, log_worker=FALSE,
        chunk_size=NA, timeout=Inf, max_calls_worker=Inf, verbose=TRUE) {

    # check if call args make sense
    if (!is.null(memory))
        template$memory = memory
    if (!is.null(template$memory) && template$memory < 50)
        stop("Worker needs about 23 MB overhead, set memory>=50")
    if (is.na(seed) || length(seed) != 1)
        stop("'seed' needs to be a length-1 integer")

    fun = match.fun(fun)
    df = as.data.frame(df, check.names=FALSE, stringsAsFactors=FALSE)
    n_calls = nrow(df)
    seed = as.integer(seed)
    check_args(fun, df, const)

    # set up workers if none provided
    if (is.null(workers)) {
        qsys_id = toupper(getOption("clustermq.scheduler", qsys_default))
        if (!is.null(n_jobs) && n_jobs == 0)
            qsys_id = "LOCAL"
        if (qsys_id != "LOCAL" && is.null(n_jobs) && is.null(job_size))
            stop("n_jobs or job_size is required")
        n_jobs = Reduce(min, c(ceiling(n_calls / job_size), n_jobs, n_calls))
    } else {
        qsys_id = class(workers$workers)[1]
        n_jobs = Inf #todo: number of workers
    }
    if (qsys_id != "LOCAL" && n_calls > n_jobs*max_calls_worker)
        stop("n_jobs and max_calls_worker provide fewer call slots than required")
    if (is.null(workers))
        workers = workers(n_jobs, reuse=FALSE, template=template,
                          log_worker=log_worker, verbose=verbose)
    workers$env(fun=fun, rettype=rettype, common_seed=seed, const=const)
    workers$pkg(pkgs)
    objs = do.call(workers$env, export)
    if (!is.null(template$memory) && 2*sum(objs$size)/1024^2 > template$memory)
        stop("Not enough memory requested to unserialize data on workers")

    # heuristic for chunk size
    if (is.na(chunk_size))
        chunk_size = round(Reduce(min, c(
            500,                    # never more than 500
            n_calls / n_jobs / 100, # each worker reports back 100 times
            n_calls / 2000,         # at most 2000 reports total
            1e4 * n_calls / utils::object.size(df)[[1]] # no more than 10 kb
        )))
    chunk_size = max(chunk_size, 1)

    # process calls
    if (inherits(workers$workers, "LOCAL")) {
        list2env(export, envir=environment(fun))
        for (pkg in pkgs) # is it possible to attach the package to fun's env?
            library(pkg, character.only=TRUE)
        re = work_chunk(df=df, fun=fun, const=const, rettype=rettype,
                        common_seed=seed, progress=TRUE)
        summarize_result(re$result, length(re$errors), length(re$warnings),
                         re[c("errors", "warnings")], fail_on_error=fail_on_error)
    } else {
        master(pool=workers, iter=df, rettype=rettype,
               fail_on_error=fail_on_error, chunk_size=chunk_size,
               timeout=timeout, max_calls_worker=max_calls_worker,
               verbose=verbose)
    }
}

ssh_opts = "-oPasswordAuthentication=no -oChallengeResponseAuthentication=no"

has_ssh = function(host) {
    status = system(paste("ssh", ssh_opts, host, "'exit'"), wait=TRUE,
                    ignore.stdout=TRUE, ignore.stderr=TRUE)
    status == 0
}

has_ssh_cmq = function(host) {
    status = suppressWarnings(
        system(paste("ssh", ssh_opts, host, "'R -e \"library(clustermq)\"'"),
               wait=TRUE, ignore.stdout=TRUE, ignore.stderr=TRUE))
    status == 0
}

has_cmq = function(host) {
    status = system("R -e 'library(clustermq)'", wait=TRUE,
                    ignore.stdout=TRUE, ignore.stderr=TRUE)
    status == 0
}

context("qsys implementations")

avail = Sys.which(c("bsub", "qsub", "sbatch", "fake_scheduler.sh"))
avail = as.list(nchar(avail) != 0)
fx = function(x) x*2

test_that("local, explicit", {
    w = workers(n_jobs=4, qsys_id="local")
    r = Q(fx, x=1:3, workers=w, timeout=10L)
    success = w$cleanup()
    expect_equal(r, as.list(1:3*2))
    expect_true(success)
})

test_that("local, n_jobs=0", {
    fx = function(x) x*2
    r = Q(fx, x=1:3, n_jobs=0, timeout=10L)
    expect_equal(r, as.list(1:3*2))
})

test_that("qsys_multicore", {
    skip_on_os("windows")
    w = workers(n_jobs=4, qsys_id="multicore", reuse=FALSE)
    r = Q(fx, x=1:3, workers=w, timeout=10L)
    expect_equal(r, as.list(1:3*2))
})

test_that("qsys_multicore with reuse=TRUE", {
    skip_on_os("windows")
    w = workers(n_jobs=4, qsys_id="multicore", reuse=TRUE)
    r = Q(fx, x=1:3, workers=w, timeout=10L)
    success = w$cleanup()
    expect_equal(r, as.list(1:3*2))
    expect_true(success)
})

test_that("qsys_multiprocess (callr)", {
    skip("https://github.com/r-lib/processx/issues/236")

    w = workers(n_jobs=2, qsys_id="multiprocess", reuse=TRUE)
    r = Q(fx, x=1:3, workers=w, timeout=10L)
    success = w$cleanup()
    expect_equal(r, as.list(1:3*2))
    expect_equal(success, TRUE)
})

test_that("qsys_lsf", {
    skip_on_cran()
    skip_if_not(with(avail, bsub))
    skip_if_not(has_cmq())
    skip_if_not(has_connectivity(Sys.info()["nodename"]))
    skip_on_os("windows")
    w = workers(n_jobs=1, qsys_id="lsf", reuse=FALSE)
    r = Q(fx, x=1:3, workers=w, timeout=10L)
    expect_equal(r, as.list(1:3*2))
})

test_that("qsys_sge", {
    skip_on_cran()
    skip_if_not(with(avail, qsub))
    skip_if_not(has_cmq())
    skip_if_not(has_connectivity(Sys.info()["nodename"]))
    skip_on_os("windows")
    w = workers(n_jobs=1, qsys_id="sge", reuse=FALSE)
    r = Q(fx, x=1:3, workers=w, timeout=10L)
    expect_equal(r, as.list(1:3*2))
})

test_that("qsys_slurm", {
    skip_on_cran()
    skip_if_not(with(avail, sbatch))
    skip_if_not(has_cmq())
    skip_if_not(has_connectivity(Sys.info()["nodename"]))
    skip_on_os("windows")
    w = workers(n_jobs=1, qsys_id="slurm", reuse=FALSE)
    r = Q(fx, x=1:3, workers=w, timeout=10L)
    expect_equal(r, as.list(1:3*2))
})

#' Construct the ZeroMQ host address
#'
#' @param node   Node or device name
#' @param ports  Range of ports to consider
#' @param n      How many addresses to return
#' @return       The possible addresses as character vector
#' @keywords internal
# @param short  Whether to use unqualified host name (before first dot)
host = function(node=getOption("clustermq.host", Sys.info()["nodename"]),
                ports=getOption("clustermq.ports", 6000:9999), n=100) {
    utils::head(sample(sprintf("tcp://%s:%i", node, ports)), n)
}

#' Fill a template string with supplied values
#'
#' @param template  A character string of a submission template
#' @param values    A named list of key-value pairs
#' @param required  Keys that must be present in the template (default: none)
#' @return          A template where placeholder fields were replaced by values
#' @keywords internal
fill_template = function(template, values, required=c()) {
    pattern = "\\{\\{\\s*([^\\s]+)\\s*(\\|\\s*[^\\s]+\\s*)?\\}\\}"
    match_obj = gregexpr(pattern, template, perl=TRUE)
    matches = regmatches(template, match_obj)[[1]]

    no_delim = substr(matches, 3, nchar(matches)-2)
    kv_str = strsplit(no_delim, "|", fixed=TRUE)
    keys = sapply(kv_str, function(s) gsub("\\s", "", s[1]))
    vals = sapply(kv_str, function(s) gsub("\\s", "", s[2]))
    if (! all(required %in% keys))
        stop("Template keys required but not provided: ",
             paste(setdiff(required, keys), collapse=", "))

    upd = keys %in% names(values)
    is_num = sapply(values, is.numeric)
    if (length(is_num) > 0)
        values[is_num] = format.default(values[is_num], scientific=FALSE, trim=TRUE)
    vals[upd] = unlist(values)[keys[upd]]
    if (any(is.na(vals)))
        stop("Template values required but not provided: ",
             paste(unique(keys[is.na(vals)]), collapse=", "))

    for (i in seq_along(matches))
        template = sub(matches[i], vals[i], template, fixed=TRUE)
    template
}

#' Lookup table for return types to vector NAs
#'
#' @keywords internal
vec_lookup = list(
    "list" = list(NULL),
    "logical" = as.logical(NA),
    "numeric" = NA_real_,
    "integer" = NA_integer_,
    "character" = NA_character_,
    "lgl" = as.logical(NA),
    "dbl" = NA_real_,
    "int" = NA_integer_,
    "chr" = NA_character_
)

#' Wraps an error in a condition object
#'
#' @keywords internal
wrap_error = function(call) {
    structure(class = c("worker_error", "condition"),
              list(message=geterrmessage(), call=call))
}

#' Message format for logging
#'
#' @keywords internal
msg_fmt = function(verbose=TRUE) {
    if (verbose)
        function(...) base::message(format(Sys.time(), "%Y-%m-%d %H:%M:%OS9 | "), ...)
    else
        function(...) invisible(NULL)
}

context("util")

test_that("template filler", {
    tmpl = "this is my {{ template }}"
    values = list(template = "filled")

    filled = fill_template(tmpl, values)
    expect_equal(filled, "this is my filled")

    expect_error(fill_template(tmpl, list(key="unrelated")))
})

test_that("template default values", {
    tmpl = "this is my {{ template | default }}"
    values = list(template = "filled")

    filled1 = fill_template(tmpl, values)
    expect_equal(filled1, "this is my filled")

    filled2 = fill_template(tmpl, list())
    expect_equal(filled2, "this is my default")
})

test_that("template required key", {
    tmpl = "this is my {{ template }}"
    values = list(template = "filled")

    expect_error(fill_template(tmpl, values, required="missing"))
})

test_that("template filling works with vectors", {
    tmpl = "{{ var1 }} and {{ var2 }}"
    values = c(var1=1, var2=2)

    expect_equal(fill_template(tmpl, values), "1 and 2")
})

test_that("template numbers are not converted to sci format", {
    tmpl = "this is my {{ template }}"
    values = list(template = 100000)

    expect_equal(fill_template(tmpl, values), "this is my 100000")
})

test_that("no sci format when passing vectors", {
    tmpl = "{{ var1 }} and {{ var2 }}"
    values = c(var1=1, var2=1e6)

    expect_equal(fill_template(tmpl, values), "1 and 1000000")
})

test_that("BiocGenerics changes format dispatch (#337)", {
    # see: https://github.com/Bioconductor/BiocGenerics/blob/RELEASE_3_20/R/format.R
    setGeneric("format")
    format.list = base::format.AsIs

    tmpl = "{{ var1 }} and {{ var2 }}"
    values = c(var1=1, var2=100)
    expect_equal(fill_template(tmpl, values), "1 and 100")
})

loadModule("cmq_master", TRUE) # CMQMaster C++ class

#' Class for basic queuing system functions
#'
#' Provides the basic functions needed to communicate between machines
#' This should abstract most functions of rZMQ so the scheduler
#' implementations can rely on the higher level functionality
#'
#' @keywords internal
Pool = R6::R6Class("Pool",
    public = list(
        initialize = function(addr=sample(host()), reuse=TRUE) {
            private$master = methods::new(CMQMaster)
            # ZeroMQ allows connecting by node name, but binding must be either
            # a numerical IP or an interface name. This is a bit of a hack to
            # seem to allow node-name bindings
            nodename = Sys.info()["nodename"]
            addr = sub(nodename, "*", addr, fixed=TRUE)
            bound = private$master$listen(addr)
            private$addr = sub("0.0.0.0", nodename, bound, fixed=TRUE)
            private$timer = proc.time()
            private$reuse = reuse
        },

        print = function() {
            cat(sprintf("<clustermq> worker pool with %i member(s)\n", self$workers$n()))
        },

        info = function() {
            info = private$master$list_workers()
            times = do.call(rbind, info$time)[,1:3,drop=FALSE]
            mem = do.call(rbind, info$mem)
            do.call(data.frame, c(info[c("worker", "status")], current=list(info$worker==info$cur),
                                  info["calls"], as.data.frame(times), mem=as.data.frame(mem)))
        },
        current = function() {
            private$master$current()
        },

        add = function(qsys, n, ...) {
            self$workers = qsys$new(addr=private$addr, master=private$master, n_jobs=n, ...)
        },

        env = function(...) {
            args = list(...)
            for (name in names(args))
                private$master$add_env(name, args[[name]])
            if (length(args) == 0)
                private$master$list_env()
            else
                invisible(private$master$list_env())
        },

        pkg = function(...) {
            args = as.list(...)
            for (elm in args)
                private$master$add_pkg(elm)
        },

        send_eval = function(cmd, ...) {
            pcall = quote(substitute(cmd))
            cmd = as.expression(do.call(substitute, list(eval(pcall), env=list(...))))
            invisible(private$master$send_eval(cmd))
        },
        send = function(cmd, ...) {
            .Deprecated("send_eval")
            pcall = quote(substitute(cmd))
            cmd = as.expression(do.call(substitute, list(eval(pcall), env=list(...))))
            invisible(private$master$send_eval(cmd))
        },
        send_shutdown = function() {
            private$master$send_shutdown()
        },
        send_wait = function(wait=50) {
            self$send_eval(Sys.sleep(wait/1000), wait=wait)
        },

        recv = function(timeout=-1L) {
            private$master$recv(timeout)
        },

        cleanup = function(timeout=5) {
            success = private$master$close(as.integer(timeout*1000))
            success = self$workers$cleanup(success, timeout) # timeout left?

            info = self$info()
            max_mem = max(c(0, info$mem.max), na.rm=TRUE)
            max_mem_str = format(structure(max_mem, class="object_size"), units="auto")
            if (max_mem_str == "0 bytes")
                max_mem_str = "NA"

            if (nrow(info) > 0) {
                wt = lapply(info[c("user.self", "sys.self", "elapsed")], mean, na.rm=TRUE)
            } else {
                wt = rep(NA, 3)
            }
            rt = proc.time() - private$timer
            rt3_fmt = difftime(as.POSIXct(rt[[3]], origin="1970-01-01"),
                               as.POSIXct(0, origin="1970-01-01"), units="auto")
            rt3_str = sprintf("%.1f %s", rt3_fmt, attr(rt3_fmt, "units"))

            fmt = "Master: [%s %.1f%% CPU]; Worker: [avg %.1f%% CPU, max %s]"
            message(sprintf(fmt, rt3_str, 100*(rt[[1]]+rt[[2]])/rt[[3]],
                            100*(wt[[1]]+wt[[2]])/wt[[3]], max_mem_str))

            invisible(success)
        },

        workers = NULL
    ),

    active = list(
        workers_total = function() private$master$workers_total(),
        workers_running = function() private$master$workers_running(),
        reusable = function() private$reuse
    ),

    private = list(
        master = NULL,
        addr = NULL,
        timer = NULL,
        reuse = NULL,

        finalize = function() {
            private$master$close(0L)
        }
    ),

    cloneable = FALSE
)

context("ssh proxy")

has_localhost = has_connectivity("127.0.0.1")

# in the following 2 tests, passing the context is deactivated because running
# the first test twice leads to a segfault; not sure why, fix this eventually
test_that("simple forwarding works", {
    skip_if_not(has_localhost)

    m = methods::new(CMQMaster)
    p = methods::new(CMQProxy)#, m$context())
    w = methods::new(CMQWorker)#, m$context())
    addr1 = m$listen("tcp://127.0.0.1:*")#"inproc://master")
    addr2 = p$listen("tcp://127.0.0.1:*")#"inproc://proxy")
    m$add_pending_workers(1L)
    p$connect(addr1, 500L)
    w$connect(addr2, 500L)
    expect_true(p$process_one())
    expect_null(m$recv(500L)) # worker up
    m$send_eval(5 + 2)
    expect_true(p$process_one())
    expect_true(w$process_one())
    expect_true(p$process_one())
    result = m$recv(500L)
    expect_equal(result, 7)

    w$close()
    p$close(0L)
    m$close(0L)
})

test_that("proxy communication yields submit args", {
    skip_if_not(has_localhost)
    skip_on_cran()

    m = methods::new(CMQMaster)
    p = methods::new(CMQProxy)#, m$context())
    addr1 = m$listen("tcp://127.0.0.1:*")#"inproc://master")
    addr2 = p$listen("tcp://127.0.0.1:*")#"inproc://proxy")

    # direct connection, no ssh forward here
    p$connect(addr1, 500L)
    p$proxy_request_cmd()
    m$proxy_submit_cmd(list(n_jobs=1), 500L)
    args = p$proxy_receive_cmd()

    expect_true(inherits(args, "list"))
    expect_true("n_jobs" %in% names(args))

    p$close(0L)
    m$close(0L)
})

test_that("using the proxy without pool and forward", {
    skip_on_cran()
    skip_on_os("windows")
    skip_if_not(has_localhost)
    skip_if(toupper(getOption("clustermq.scheduler", qsys_default)) != "MULTICORE",
            message="options(clustermq.scheduler') must be 'MULTICORE'")

    m = methods::new(CMQMaster)
    addr = m$listen("tcp://127.0.0.1:*")
    p = parallel::mcparallel(ssh_proxy(sub(".*:", "", addr)))

    m$proxy_submit_cmd(list(n_jobs=1), 10000L)
    m$add_pending_workers(1L)
    expect_null(m$recv(2000L)) # worker 1 up
    m$send_eval(5 + 2)
    expect_equal(m$recv(500L), 7) # collect results

    m$send_shutdown()
    m$close(500L)

    pr = parallel::mccollect(p, wait=TRUE, timeout=0.5)
    expect_equal(names(pr), as.character(p$pid))
})

test_that("using the proxy without pool and forward, 2 workers", {
    skip_on_cran()
    skip_on_os("windows")
    skip_if_not(has_localhost)
    skip_if(toupper(getOption("clustermq.scheduler", qsys_default)) != "MULTICORE",
            message="options(clustermq.scheduler') must be 'MULTICORE'")

    m = methods::new(CMQMaster)
    addr = m$listen("tcp://127.0.0.1:*")
    p = parallel::mcparallel(ssh_proxy(sub(".*:", "", addr)))

    m$proxy_submit_cmd(list(n_jobs=2), 10000L)
    m$add_pending_workers(2L)
    expect_null(m$recv(2000L)) # worker 1 up
    m$send_eval({ Sys.sleep(0.5); 5 + 2 })
    expect_null(m$recv(500L)) # worker 2 up
    m$send_eval({ Sys.sleep(0.5); 3 + 1 })
    r1 = m$recv(1000L)
    m$send_shutdown()
    r2 = m$recv(500L)
    m$send_shutdown()
    expect_equal(sort(c(r1,r2)), c(4,7))

    m$close(500L)
    pr = parallel::mccollect(p, wait=TRUE, timeout=0.5)
    expect_equal(names(pr), as.character(p$pid))
})

test_that("full SSH connection", {
    skip_on_cran()
    skip_on_os("windows")
    skip_if_not(has_localhost)
    skip_if_not(has_ssh_cmq("127.0.0.1"))

    # 'LOCAL' mode (default) will not set up required sockets
    # 'SSH' mode would lead to circular connections
    # schedulers may have long delay (they start in fresh session, so no path)
    sched = getOption("clustermq.scheduler", qsys_default)
    skip_if(is.null(sched) || toupper(sched) != "MULTICORE",
            message="options(clustermq.scheduler') must be 'MULTICORE'")
    options(clustermq.template = "SSH", clustermq.ssh.host="127.0.0.1")

    w = workers(n_jobs=1, qsys_id="ssh", reuse=FALSE)
    result = Q(identity, 42, n_jobs=1, timeout=10L, workers=w)
    expect_equal(result, list(42))

    w = workers(n_jobs=2, qsys_id="ssh", reuse=FALSE)
    result = clustermq::Q(Sys.sleep, time=c(1,2), n_jobs=2)
    expect_equal(result, list(NULL, NULL))
})

context("pool")

skip_if_not(has_connectivity("127.0.0.1"))

test_that("starting and stopping multicore", {
    skip_on_os("windows")

    w = workers(1, qsys_id="multicore")
    expect_equal(w$workers_total, 1)
    expect_equal(w$workers_running, 0)
    expect_null(w$recv(5000L))
    expect_equal(w$workers_running, 1)
    w$send_eval(3 + 4)
    expect_equal(w$workers_running, 1)
    expect_equal(w$recv(1000L), 7)
    expect_equal(w$workers_running, 1)
    w$send_shutdown()
    expect_equal(w$workers_running, 0)
    expect_equal(w$workers_total, 0)
    expect_error(w$send_eval(1))
    expect_error(w$recv(1000L))
    w$cleanup()
    expect_equal(w$workers_running, 0)
    expect_equal(w$workers_total, 0)
    expect_error(w$send_eval(2))
    expect_error(w$recv(1000L))
    expect_equal(w$workers_running, 0)
    expect_equal(w$workers_total, 0)
})

test_that("pending workers area cleaned up properly", {
    skip_on_os("windows")
    w = workers(1, qsys_id="multicore")
    w$cleanup()
    expect_equal(w$workers_running, 0)
    expect_equal(w$workers_total, 0)
})

test_that("calculations are really done on the worker", {
    skip_on_os("windows")
    x = 1
    y = 2
    w = workers(1, qsys_id="multicore")
    expect_null(w$recv(5000L))
    w$env(y = 3)
    w$send_eval(x + y, x=4)
    expect_equal(w$recv(1000L), 7)
    w$send_shutdown()
    w$cleanup()
})

test_that("call references are matched properly", {
    skip_on_os("windows")
    skip_on_cran()

    w = workers(2, qsys_id="multicore")
    expect_null(w$recv(5000L))

    r1 = w$send_eval({Sys.sleep(1); 1})
    expect_null(w$recv(1000L))
    r2 = w$send_eval(2)
    expect_equal(w$recv(500L), 2)
    expect_equal(w$current()$call_ref, r2)
    w$send_shutdown()
    expect_equal(w$recv(2000L), 1)
    expect_equal(w$current()$call_ref, r1)
    w$cleanup()
})

test_that("multiprocess", {
    skip("https://github.com/r-lib/processx/issues/236")

    w = workers(1, qsys_id="multiprocess")
    expect_null(w$recv())
    w$send_eval(3 + 5)
    expect_equal(w$recv(), 8)
    w$send_shutdown()
    w$cleanup()
})

test_that("work_chunk on multiprocess", {
    skip("https://github.com/r-lib/processx/issues/236")

    w = workers(1, qsys_id="multiprocess")
    expect_null(w$recv())
    w$send_eval(clustermq:::work_chunk(chunk, `+`), chunk=list(a=1:3, b=4:6))
    res = w$recv()
    expect_equal(res$result, list(`1`=5, `2`=7, `3`=9))
    expect_equal(res$warnings, list())
    expect_equal(res$errors, list())
    w$send_shutdown()
    w$cleanup()
})

test_that("worker creation passes template filling values", {
    TMPL_FILLER <<- R6::R6Class("TMPL_FILLER",
        inherit = QSys,
        public = list(
            initialize = function(addr, n_jobs, master, ...) {
                super$initialize(addr=addr, master=master, template="LSF")
                self$filled = private$fill_options(...)
            },
            filled = list()
        )
    )
    old_defaults = getOption("clustermq.defaults")
    on.exit(options(clustermq.defaults = old_defaults))
    options(clustermq.defaults = list(cores="defaults_test", memory="invalid"))

    w = workers(1, qsys_id="tmpl_filler", template=list(memory="test"))
    rm(TMPL_FILLER, envir=.GlobalEnv)

    expect_equal(w$workers$filled$memory, "test")
    expect_equal(w$workers$filled$cores, "defaults_test")
})

context("worker usage")

test_that("connect to invalid endpoint errors", {
    w = methods::new(CMQWorker)
    expect_error(w$connect("tcp://localhost:12345", 0L))
    w$close()
})

test_that("recv without pending workers errors before timeout", {
    m = methods::new(CMQMaster)
    addr = m$listen("inproc://endpoint")
    expect_error(m$recv(-1L))
    m$close(500L)
})

test_that("recv timeout works", {
    m = methods::new(CMQMaster)
    addr = m$listen("inproc://endpoint")
    m$add_pending_workers(1L)
    expect_error(m$recv(0L))
    m$close(500L)
})

test_that("worker evaluation", {
    m = methods::new(CMQMaster)
    w = methods::new(CMQWorker, m$context())
    addr = m$listen("inproc://endpoint")
    m$add_pending_workers(1L)
    w$connect(addr, 500L)

    m$recv(500L)
    m$send_eval(expression(5 * 2))
    status = w$process_one()
    result = m$recv(500L)

    expect_true(status)
    expect_equal(result, 10)

    w$close()
    m$close(500L)
})

test_that("export variable to worker", {
    m = methods::new(CMQMaster)
    w = methods::new(CMQWorker, m$context())
    addr = m$listen("inproc://endpoint")
    m$add_pending_workers(1L)
    w$connect(addr, 500L)

    m$add_env("x", 3)
    m$recv(500L)
    m$send_eval(expression(5 + x))
    status = w$process_one()
    result = m$recv(500L)
    expect_true(status)
    expect_equal(result, 8)

    m$add_env("x", 5)
    m$send_eval(expression(5 + x))
    status = w$process_one()
    result = m$recv(500L)
    expect_true(status)
    expect_equal(result, 10)

    w$close()
    m$close(500L)
})

test_that("load package on worker", {
    m = methods::new(CMQMaster)
    w = methods::new(CMQWorker, m$context())
    addr = m$listen("inproc://endpoint")
    m$add_pending_workers(1L)
    w$connect(addr, 500L)

    m$add_pkg("parallel")

    m$recv(500L)
    m$send_eval(expression(splitIndices(1, 1)[[1]]))
    status = w$process_one()
    result = m$recv(500L)

    expect_true(status)
    expect_equal(result, 1)

    w$close()
    m$close(500L)
})

test_that("errors are sent back to master", {
    skip("this works interactively but evaluates the error on testthat")

    m = methods::new(CMQMaster)
    w = methods::new(CMQWorker, m$context())
    addr = m$listen("inproc://endpoint")
    m$add_pending_workers(1L)
    w$connect(addr, 500L)

    m$recv(500L)
    m$send_eval(expression(stop("errmsg")))
    status = w$process_one()
    result = m$recv(500L)

    expect_true(status)
    expect_true(inherits(result, c("condition", "worker_error")))

    w$close()
    m$close(500L)
})

test_that("worker R API", {
    skip_on_os("windows")
    skip_if_not(has_connectivity("127.0.0.1")) # -> this or inproc w/ passing context

    m = methods::new(CMQMaster)
    addr = m$listen("tcp://127.0.0.1:*")
    m$add_pending_workers(1L)
#    addr = m$listen("inproc://endpoint") # mailbox.cpp assertion error

    p = parallel::mcparallel(worker(addr))
    expect_null(m$recv(5000L))
    m$send_eval(expression(5 + 1))
    res = m$recv(500L)
    expect_equal(res[[1]], 6)

    m$send_shutdown()
    pc = parallel::mccollect(p, wait=TRUE, timeout=0.5)
    expect_equal(pc[[1]], NULL)
    m$close(500L)
})

test_that("worker memory tracks non-R allocations", {
    skip_on_os("windows")
    skip_on_cran()
    skip_if_not(has_connectivity("127.0.0.1"))

    m = methods::new(CMQMaster)
    addr = m$listen("tcp://127.0.0.1:*")
    m$add_pending_workers(1L)
    p = parallel::mcparallel(worker(addr))

    expect_null(m$recv(5000L))
    before = m$list_workers()$mem[[1]]
    m$add_env("alloc_non_r_bytes", clustermq:::alloc_non_r_bytes)
    m$send_eval(expression({alloc_non_r_bytes(100 * 1024^2); gc(); TRUE}))
    expect_true(m$recv(2000L))
    after = m$list_workers()$mem[[1]]

    m$send_shutdown()
    pc = parallel::mccollect(p, wait=TRUE, timeout=0.5)
    expect_equal(pc[[1]], NULL)
    expect_equal(unname(after - before)/1024^2, c(0, 100), tolerance=10)
    m$close(500L)
})

test_that("communication with two workers", {
    skip_on_os("windows")
    skip_if_not(has_connectivity("127.0.0.1"))

    m = methods::new(CMQMaster)
    addr = m$listen("tcp://127.0.0.1:*")
    m$add_pending_workers(2L)
    w1 = parallel::mcparallel(worker(addr))
    w2 = parallel::mcparallel(worker(addr))

    expect_null(m$recv(5000L)) # worker 1 up
    m$send_eval(expression({ Sys.sleep(0.5); 5 + 2 }))
    expect_null(m$recv(500L)) # worker 2 up
    m$send_eval(expression({ Sys.sleep(0.5); 3 + 1 }))
    r1 = m$recv(1000L)
    m$send_shutdown()
    r2 = m$recv(1000L)
    m$send_shutdown()
    expect_equal(sort(c(r1, r2)), c(4,7))

    coll1 = parallel::mccollect(w1, wait=TRUE, timeout=0.5)
    expect_equal(names(coll1), as.character(w1$pid))
    coll2 = parallel::mccollect(w2, wait=TRUE, timeout=0.5)
    expect_equal(names(coll2), as.character(w2$pid))

    m$close(500L)
})

#' Select the queueing system on package loading
#'
#' This is done by setting the variable 'qsys' in the package environment
#' to the object that contains the desired queueing system.
#'
#' @param libname  default arg for compatibility
#' @param pkgname  default arg for compatibility
#' @keywords internal
.onLoad = function(libname, pkgname) {
    qsys_default = toupper(getOption('clustermq.scheduler'))

    if (length(qsys_default) == 0) {
        qname = c("SLURM", "LSF", "SGE", "LOCAL")
        exec = Sys.which(c("sbatch", "bsub", "qsub"))
        select = c(which(nchar(exec) > 0), 4)[1]
        qsys_default = qname[select]
    }

    assign("qsys_default", qsys_default, envir=parent.env(environment()))
}

#' Report queueing system on package attach if not set
#'
#' @param libname  default arg for compatibility
#' @param pkgname  default arg for compatibility
#' @keywords internal
.onAttach = function(libname, pkgname) {
    if (is.null(getOption("clustermq.scheduler"))) {
        packageStartupMessage("* Option 'clustermq.scheduler' not set, ", "defaulting to ", sQuote(qsys_default))
        packageStartupMessage("--- see: https://mschubert.github.io/clustermq/articles/userguide.html#configuration")
    }
    if (!libzmq_has_draft()) {
        packageStartupMessage("* Worker disconnect monitor is disabled")
        packageStartupMessage("--- see: https://mschubert.github.io/clustermq/articles/userguide.html#installation")
    }
}

#' Print a summary of errors and warnings that occurred during processing
#'
#' @param result      A list or vector of the processing result
#' @param n_errors    How many errors occurred
#' @param n_warnings  How many warnings occurred
#' @param cond_msgs   Error and warnings messages, we display first 50
#' @param at          How many calls were procesed  up to this point
#' @param fail_on_error  Stop if error(s) occurred
#' @keywords internal
summarize_result = function(result, n_errors, n_warnings,
                            cond_msgs, at=length(result), fail_on_error=TRUE) {

    cond_msgs$errors = cond_msgs$errors[order(as.integer(names(cond_msgs$errors)))]
    cond_msgs$warnings = cond_msgs$warnings[order(as.integer(names(cond_msgs$warnings)))]
    cond_msgs = utils::head(c(cond_msgs$errors, cond_msgs$warnings), 50)
    detail = paste(trimws(unlist(cond_msgs)), collapse="\n")

    if (n_errors > 0) {
        msg = sprintf("%i/%i jobs failed (%i warnings)", n_errors, at, n_warnings)
        if (fail_on_error)
            stop(msg, ". Stopping.\n", detail, call.=FALSE)
        else
            warning(msg, "\n", detail, immediate.=TRUE, call.=FALSE)
    } else if (n_warnings > 0) {
        msg = sprintf("%i warnings occurred in processing\n", n_warnings)
        warning(msg, detail, immediate.=TRUE, call.=FALSE)
    }
    unname(result)
}

loadModule("cmq_master", TRUE) # CMQMaster C++ class

#' Class for basic queuing system functions
#'
#' Provides the basic functions needed to communicate between machines
#' This should abstract most functions of rZMQ so the scheduler
#' implementations can rely on the higher level functionality
#'
#' @keywords internal
QSys = R6::R6Class("QSys",
    public = list(
        # Create a class instance
        #
        # Initializes ZeroMQ and sets and sets up our primary communication socket
        #
        # @param addr    Vector of possible addresses to bind
        # @param bind    Whether to bind 'addr' or just refer to it
        initialize = function(addr, master, template=NULL) {
            private$master = master
            private$addr = addr
            private$port = as.integer(sub(".*:", "", addr))

            if (!is.null(template)) {
                if (!file.exists(template))
                    template = system.file(paste0(template, ".tmpl"),
                                           package="clustermq", mustWork=TRUE)
                if (file.exists(template)) {
                    private$template_file = template
                    private$template = readChar(template, file.info(template)$size)
                } else
                    stop("Template file does not exist: ", sQuote(template))
            }
            private$defaults = getOption("clustermq.defaults", list())
        },

        cleanup = function(success, timeout) TRUE,

        n = function() private$workers_total
    ),

    private = list(
        master = NULL,
        addr = NULL,
        port = NULL,
        template = NULL,
        template_file = NULL,
        workers_total = NULL,
        defaults = list(),
        is_cleaned_up = NULL,

        fill_options = function(...) {
            values = utils::modifyList(private$defaults, list(...))
            values$master = private$addr
            values$auth = paste(sample(letters, 5, TRUE), collapse="")
            if (!"job_name" %in% names(values))
                values$job_name = paste0("cmq", private$port)
            private$workers_total = values$n_jobs
            values
        },

        template_error = function(scheduler, status, filled) {
            message("\nThe filled ", scheduler, " template ", sQuote(private$template_file),
                    " was:\n", '"""', "\n", filled, '"""', "\n")
            message("see: https://mschubert.github.io/clustermq/articles/userguide.html#scheduler-setup\n")
            stop("Job submission failed with error code ", status, call.=FALSE)
        }
    ),

    cloneable = FALSE
)

#' SGE scheduler functions
#'
#' Derives from QSys to provide SGE-specific functions
#'
#' @keywords internal
SGE = R6::R6Class("SGE",
    inherit = QSys,

    public = list(
        initialize = function(addr, n_jobs, master, ..., template=getOption("clustermq.template", "SGE"),
                              log_worker=FALSE, log_file=NULL, verbose=TRUE) {
            super$initialize(addr=addr, master=master, template=template)

            opts = private$fill_options(n_jobs=n_jobs, ...)
            private$job_name = opts$job_name
            if (!is.null(opts$log_file))
                opts$log_file = normalizePath(opts$log_file, mustWork=FALSE)
            else if (log_worker)
                opts$log_file = sprintf("%s-%s.log", private$job_name, private$array_idx)
            filled = fill_template(private$template, opts, required=c("master", "n_jobs"))

            if (verbose)
                message("Submitting ", n_jobs, " worker jobs to ", class(self)[1],
                        " as ", sQuote(private$job_id), " ...")

            private$qsub_stdout = system2("qsub", input=filled, stdout=TRUE)
            status = attr(private$qsub_stdout, "status")
            if (!is.null(status) && status != 0)
                private$template_error("SGE", status, filled)
            private$job_id = private$job_name
            private$master$add_pending_workers(n_jobs)
            private$is_cleaned_up = FALSE
        },

        cleanup = function(success, timeout) {
            private$is_cleaned_up = success
            private$finalize()
        }
    ),

    private = list(
        qsub_stdout = NULL,
        job_name = NULL,
        job_id   = NULL,
        array_idx = "$TASK_ID",

        finalize = function(quiet = TRUE) { # self$workers_running == 0
            if (!private$is_cleaned_up) {
                system(paste("qdel", private$job_id),
                       ignore.stdout=quiet, ignore.stderr=quiet, wait=FALSE)
            }
            private$is_cleaned_up = TRUE
        }
    ),

    cloneable = FALSE
)

#' Class for Open Cluster Scheduler (OCS)
OCS = R6::R6Class("OCS",
    inherit = QSys,

    public = list(
        initialize = function(addr, n_jobs, master, ..., template=getOption("clustermq.template", class(self)[1]),
                              log_worker=FALSE, log_file=NULL, verbose=TRUE) {
            super$initialize(addr=addr, master=master, template=template)

            opts = private$fill_options(n_jobs=n_jobs, ...)
            filled = fill_template(private$template, opts, required=c("master", "n_jobs"))
            qsub_stdout = system2("qsub", input=filled, stdout=TRUE)

            status = attr(qsub_stdout, "status")
            if (!is.null(status) && status != 0)
                private$template_error(class(self)[1], status, filled)

            private$job_id = regmatches(qsub_stdout, regexpr("^[0-9]+", qsub_stdout))
            if (length(private$job_id) == 0)
                private$template_error(class(self)[1], qsub_stdout, filled)

            if (verbose)
                message("Submitted ", n_jobs, " worker tasks to ", class(self)[1], " as array job ", private$job_id, " ...")

            private$master$add_pending_workers(n_jobs)
        },

        cleanup = function(success, timeout) {
            system(paste("qdel", private$job_id), ignore.stdout=TRUE, ignore.stderr=TRUE, wait=FALSE)
        }
    ),

    private = list(
        job_id   = NULL
    ),

    cloneable = FALSE
)

#' Class for Gridware Cluster Scheduler (GCS)
GCS = R6::R6Class("GCS",
    inherit = OCS,
    cloneable = FALSE

    # no changes needed, but we want to have a separate class for GCS to allow for GCS-specific
    # templates and enterprise edition options
)

PBS = R6::R6Class("PBS",
    inherit = SGE,

    public = list(
        initialize = function(..., template=getOption("clustermq.template", "PBS")) {
            super$initialize(..., template=template)
            private$array_idx = "$PBS_ARRAY_INDEX"
            private$job_id = private$qsub_stdout[1]
        }
    ),

    cloneable = FALSE
)

TORQUE = R6::R6Class("TORQUE",
    inherit = PBS,

    public = list(
        initialize = function(..., template=getOption("clustermq.template", "TORQUE")) {
            super$initialize(..., template=template)
            private$array_idx = "$PBS_ARRAYID"
        }
    ),

    cloneable = FALSE
)

#' SSH scheduler functions
#'
#' Derives from QSys to provide SSH-specific functions
#'
#' @keywords internal
SSH = R6::R6Class("SSH",
    inherit = QSys,

    public = list(
        initialize = function(addr, n_jobs, ..., master,
                              ssh_host = getOption("clustermq.ssh.host"),
                              ssh_log = getOption("clustermq.ssh.log"),
                              template = getOption("clustermq.template", "SSH"),
                              verbose = TRUE) {
            if (is.null(ssh_host))
                stop("Option 'clustermq.ssh.host' required for SSH but not set")
            if (!grepl("^tcp://", addr))
                stop("SSH QSys must connect via tcp:// not ", sQuote(addr))

            super$initialize(addr=addr, master=master, template=template)
            private$template = paste(trimws(readLines(textConnection(private$template))), collapse=" ")

            # set forward and run ssh.r (send port, master)
            opts = private$fill_options(ssh_log=ssh_log, ssh_host=ssh_host)
            ssh_cmd = fill_template(private$template, opts,
                required=c("local_port", "ssh.hpc_fwd_port", "ssh_host"))

            # wait for ssh to connect
            message(sprintf("Connecting to %s via SSH ...", sQuote(ssh_host)))
            system(ssh_cmd, wait=TRUE, ignore.stdout=TRUE, ignore.stderr=TRUE)

            master$add_pending_workers(n_jobs)
            args = c(list(...), list(n_jobs=n_jobs))
            init_timeout = getOption("clustermq.ssh.timeout", 10)
            tryCatch(private$master$proxy_submit_cmd(args, init_timeout*1000),
                error = function(e) {
                    if (grepl("timed out", conditionMessage(e))) {
                        stop("Remote R process did not respond after ",
                             init_timeout, " seconds. Check your SSH server log.")
                    } else stop(e)
            })

            private$workers_total = args$n_jobs
        },

        cleanup = function(success, timeout) {
            private$finalize()
            TRUE
        }
    ),

    private = list(
        ssh_proxy_running = TRUE,

        fill_options = function(...) {
            args = list(...)
            args$local_port = sub(".*:", "", private$addr)
            args$ssh.hpc_fwd_port=getOption("clustermq.ssh.hpc_fwd_port", 50000:55000) 
            if (length(args$ssh.hpc_fwd_port) > 1)
                args$ssh.hpc_fwd_port = sample(args$ssh.hpc_fwd_port, 1)
            utils::modifyList(private$defaults, args)
        },

        finalize = function(quiet = self$workers_running == 0) {
#            if (private$ssh_proxy_running) {
#                private$zmq$send(
#                    list(id="PROXY_STOP", finalize=!private$is_cleaned_up),
#                    "proxy"
#                )
#            }
            private$ssh_proxy_running = FALSE
        }
    ),

    cloneable = FALSE
)

#' Master controlling the workers
#'
#' exchanging messages between the master and workers works the following way:
#'  * we have submitted a job where we don't know when it will start up
#'  * it starts, sends is a message list(id=0) indicating it is ready
#'  * we send it the function definition and common data
#'    * we also send it the first data set to work on
#'  * when we get any id > 0, it is a result that we store
#'    * and send the next data set/index to work on
#'  * when computatons are complete, we send id=0 to the worker
#'    * it responds with id=-1 (and usage stats) and shuts down
#'
#' @param pool           Instance of Pool object
#' @param iter           Objects to be iterated in each function call
#' @param rettype        Return type of function
#' @param fail_on_error  If an error occurs on the workers, continue or fail?
#' @param chunk_size     Number of function calls to chunk together
#'                       defaults to 100 chunks per worker or max. 500 kb per chunk
#' @param timeout         Maximum time in seconds to wait for worker (default: Inf)
#' @param max_calls_worker  Maxmimum number of function calls that will be sent to one worker
#' @param verbose        Print progress messages
#' @return               A list of whatever `fun` returned
#' @keywords  internal
master = function(pool, iter, rettype="list", fail_on_error=TRUE,
                  chunk_size=NA, timeout=Inf, max_calls_worker=Inf, verbose=TRUE) {
    # prepare empty variables for managing results
    n_calls = nrow(iter)
    job_result = rep(vec_lookup[[rettype]], n_calls)
    submit_index = 1:chunk_size
    jobs_running = 0
    cond_msgs = list(warnings=list(), errors=list())
    n_errors = 0
    n_warnings = 0
    shutdown = FALSE
    kill_workers = FALSE
    penv = pool$env(work_chunk=work_chunk)
    obj_size = structure(sum(penv$size), class="object_size")
    obj_size_fmt = format(obj_size, big.mark=",", units="auto")
    if (is.infinite(timeout)) {
        timeout = -1L
    } else {
        timeout = timeout * 1000 # Rcpp API uses msec
    }

    #TODO: warn before serialization, create pool+env & then submit
    if (obj_size/1e6 > getOption("clustermq.data.warning", 500))
        warning("Common data is ", obj_size_fmt, ". Recommended limit is ",
                getOption("clustermq.data.warning", 500),
                " Mb (set by clustermq.data.warning option)", immediate.=TRUE)

    if (!pool$reusable)
        on.exit(pool$cleanup())

    if (verbose) {
        message("Running ", format(n_calls, big.mark=",", scientific=FALSE),
                " calculations (", nrow(penv), " objs/", obj_size_fmt,
                " common; ", chunk_size, " calls/chunk) ...")
        pb = progress::progress_bar$new(total = n_calls,
                format = "[:bar] :percent (:wup/:wtot wrk) eta: :eta")
        pb$tick(0, tokens=list(wtot=pool$workers_total, wup=pool$workers_running))
    }

    # main event loop
    while((!shutdown && submit_index[1] <= n_calls) || jobs_running > 0) {
        msg = pool$recv(timeout)
        if (inherits(msg, "worker_error"))
            stop("Worker Error: ", msg)

        if (verbose)
            pb$tick(length(msg$result),
                    tokens=list(wtot=pool$workers_total, wup=pool$workers_running))

        # process the result data if we got some
        if (!is.null(msg$result)) {
            call_id = names(msg$result)
            jobs_running = jobs_running - length(call_id)
            job_result[as.integer(call_id)] = msg$result

            n_warnings = n_warnings + length(msg$warnings)
            n_errors = n_errors + length(msg$errors)
            if (n_errors > 0 && fail_on_error == TRUE)
                shutdown = TRUE
            if (length(cond_msgs$warnings) < 50)
                cond_msgs$warnings = c(cond_msgs$warnings, msg$warnings)
            if (length(cond_msgs$errors) < 50)
                cond_msgs$errors = c(cond_msgs$errors, msg$errors)
        }

        if (shutdown || pool$current()$calls >= max_calls_worker) {
            pool$send_shutdown()
            next
        }

        if (submit_index[1] <= n_calls) {
            # if we have work, send it to the worker
            submit_index = submit_index[submit_index <= n_calls]
            pool$send_eval(work_chunk(chunk, fun=fun, const=const, rettype=rettype,
                common_seed=common_seed), chunk=chunk(iter, submit_index))
            jobs_running = jobs_running + length(submit_index)
            submit_index = submit_index + chunk_size

            # adapt chunk size towards end of processing
            cs = ceiling((n_calls - submit_index[1]) / pool$workers_running)
            if (cs < chunk_size) {
                chunk_size = max(cs, 1)
                submit_index = submit_index[1:chunk_size]
            }

        } else if (pool$reusable) {
            pool$send_wait()
        } else { # or else shut it down
            pool$send_shutdown()
        }
    }

    summarize_result(job_result, n_errors, n_warnings, cond_msgs,
                     min(submit_index)-1, fail_on_error)
}

#' Register clustermq as `foreach` parallel handler
#'
#' @param ...  List of arguments passed to the `Q` function, e.g. n_jobs
#' @export
register_dopar_cmq = function(...) {
    dots = list(...)
    workers = NA
    if ("n_jobs" %in% names(dots))
        workers = dots$n_jobs
    info = function(data, item) {
        switch(item,
               name = "clustermq",
               version = utils::packageVersion("clustermq"),
               workers = workers)
    }
    foreach::setDoPar(cmq_foreach, data=dots, info=info)
}

#' clustermq foreach handler
#'
#' @param obj  Returned from foreach::foreach, containing the following variables:
#'   args    : Arguments passed, each as a call
#'   argnames: character vector of arguments passed
#'   evalenv : Environment where to evaluate the arguments
#'   export  : character vector of variable names to export to nodes
#'   packages: character vector of required packages
#'   verbose : whether to print status messages [logical]
#'   errorHandling: string of function name to call error with, e.g. "stop"
#' @param expr   An R expression in curly braces
#' @param envir  Environment where to evaluate the arguments
#' @param data   Common arguments passed by register_dopcar_cmq(), e.g. n_jobs
#' @keywords  internal
cmq_foreach = function(obj, expr, envir, data) {
    stopifnot(inherits(obj, "foreach"))
    stopifnot(inherits(envir, "environment"))

    it = iterators::iter(obj)
    args_df = do.call(rbind, as.list(it))

    # if we call a function by name, add it to the export list
    if (is.call(expr) && as.character(expr[[1]]) != "{")
        obj$export = c(as.character(expr[[1]]), obj$export)

    # wrap whatever we call in a function for use with Q(...)
    fun = function(...) NULL
    add = stats::setNames(replicate(ncol(args_df), substitute()), obj$argnames)
    formals(fun) = c(add, formals(fun))
    body(fun) = expr

    # scan 'expr' for exports, eval and add objects ref'd in '.export'
    globs = globals::globalsOf(expr, envir=envir, mustExist=FALSE)
    globs = globs[! names(globs) %in% c(names(formals(fun)), ls(baseenv()))]
    data$export = utils::modifyList(as.list(data$export), globs, keep.null=TRUE)

    # make sure packages are loaded on the dopar target
    if (length(obj$packages) > 0)
        data$pkgs = unique(c(data$pkgs, obj$packages))

    result = do.call(Q_rows, c(list(df=args_df, fun=fun), data))

    accum = foreach::makeAccum(it)
    accum(result, tags=seq_along(result))
    foreach::getResult(it)
}

context("foreach")

skip_if_not_installed("foreach")

foreach = foreach::foreach
`%dopar%` = foreach::`%dopar%`
`%do%` = foreach::`%do%`
register_dopar_cmq(n_jobs=0)

test_that("foreach::getDoParWorkers() returns n_jobs", {
    expect_equal(foreach::getDoParWorkers(), 0)
})

test_that("simple foreach registration works", {
    res = foreach(i=1:3) %dopar% sqrt(i)
    cmp = foreach(i=1:3) %do% sqrt(i)

    expect_equal(res, cmp)
})

test_that(".export objects are exported", {
    y = 5
    res = foreach(x=1:3, .export="y") %dopar% { x + y }
    cmp = foreach(x=1:3, .export="y") %do% { x + y }

    expect_equal(res, cmp)
#    expect_error(foreach(x=1:3) %dopar% { x + y })
})

test_that(".packages are loaded", {
    expect_error(foreach(i="a string") %dopar% { md5sum(i) })
    res = foreach(i="a string", .packages="tools") %dopar% { md5sum(i) }
    cmp = foreach(i="a string") %do% { md5sum(i) }
    expect_equal(res, cmp)
})

test_that(".combine is respected", {
    res = foreach(i=1:3, .combine=c) %dopar% sqrt(i)
    cmp = foreach(i=1:3, .combine=c) %do% sqrt(i)
    expect_equal(res, cmp)

    res = foreach(i=1:3, .combine=append) %dopar% list(a=1, b=2)
    cmp = foreach(i=1:3, .combine=append) %do% list(a=1, b=2)
    expect_equal(res, cmp)

    res = foreach(i=1:3, .combine=cbind) %dopar% sqrt(i)
    cmp = foreach(i=1:3, .combine=cbind) %do% sqrt(i)
    expect_equal(res, cmp)

    res = foreach(i=1:3, .combine=rbind) %dopar% sqrt(i)
    cmp = foreach(i=1:3, .combine=rbind) %do% sqrt(i)
    expect_equal(res, cmp)
})

test_that("no matrix unlisting (#143)", {
    fx = function(x) matrix(c(1,2)+x, ncol=1)
    res = foreach(i=1:3) %dopar% fx(i)
    cmp = foreach(i=1:3) %do% fx(i)
    expect_equal(res, cmp)
})

test_that("automatic export in foreach", {
    fx = function(x) x + y
    y = 5
    res = foreach(x=1:3) %dopar% { x + y }
    cmp = foreach(x=1:3) %do% { x + y }
    expect_equal(res, cmp)
})

test_that("NULL objects are exported", {
    fx = function(x) is.null(x)
    y = NULL
    res = foreach(i=1) %dopar% fx(y)
    cmp = foreach(i=1) %do% fx(y)
    expect_equal(res, cmp)
})

test_that("external worker", {
    skip_on_os("windows")

    old_sched = getOption("clustermq.scheduler")
    on.exit(options(clustermq.scheduler = old_sched))
    options(clustermq.scheduler = "multicore")

    register_dopar_cmq(n_jobs=1)
    res = foreach(i=1:3) %dopar% sqrt(i)
    cmp = foreach(i=1:3) %do% sqrt(i)
    expect_equal(res, cmp)
})

test_that("foreach works via BiocParallel", {
    skip_on_os("windows")
    skip_if_not_installed("BiocParallel")

    old_sched = getOption("clustermq.scheduler")
    on.exit(options(clustermq.scheduler = old_sched))
    options(clustermq.scheduler = "multicore")

    register_dopar_cmq(n_jobs=1)
    BiocParallel::register(BiocParallel::DoparParam())
    res = BiocParallel::bplapply(1:3, sqrt)
    cmp = foreach(i=1:3) %do% sqrt(i)

    expect_equal(res, cmp)
})

loadModule("cmq_proxy", TRUE) # CMQProxy C++ class

#' SSH proxy for different schedulers
#'
#' Do not call this manually, the SSH qsys will do that
#'
#' @param fwd_port The port of the master address to connect to
#'                 (remote end of reverse tunnel)
#' @param qsys_id  Character string of QSys class to use
#' @keywords internal
ssh_proxy = function(fwd_port, qsys_id=qsys_default) {
    message = msg_fmt()

    master = sprintf("tcp://127.0.0.1:%s", fwd_port)
    p = methods::new(CMQProxy)
    p$connect(master, 10000L)

    tryCatch({
        nodename = Sys.info()["nodename"]
        addr = p$listen(sub(nodename, "*", sample(host()), fixed=TRUE))
        addr = sub("0.0.0.0", nodename, addr, fixed=TRUE)
        message("listening for workers at ", addr)

        p$proxy_request_cmd()
        args = p$proxy_receive_cmd()
        message("submit args: ", paste(mapply(paste, names(args), args, sep="="), collapse=", "))
        stopifnot(inherits(args, "list"), "n_jobs" %in% names(args))

        # set up qsys on cluster
        message("setting up qsys: ", qsys_id)
        if (toupper(qsys_id) %in% c("LOCAL", "SSH"))
            stop("Remote SSH QSys ", sQuote(qsys_id), " is not allowed")
        qsys = get(toupper(qsys_id), envir=parent.env(environment()))
        qsys = do.call(qsys$new, c(list(addr=addr, master=p), args))
        on.exit(qsys$cleanup())

        while(p$process_one()) {
            message("event at: ", Sys.time())
        }

        message("shutting down")
        p$close(1000L)

    }, error = function(e) {
        stop(e)
    })
}

loadModule("cmq_worker", TRUE) # CMQWorker C++ class
utils::globalVariables(c("common_seed", "const", "fun")) # worker .GlobalEnv

#' R worker submitted as cluster job
#'
#' Do not call this manually, the master will do that
#'
#' @param master   The master address (tcp://ip:port)
#' @param ...      Catch-all to not break older template values (ignored)
#' @param verbose  Whether to print debug messages
#' @param context  ZeroMQ context (for internal testing)
#' @keywords internal
worker = function(master, ..., verbose=TRUE, context=NULL) {
    message = msg_fmt(verbose)

    #TODO: replace this by proper authentication
    auth = Sys.getenv("CMQ_AUTH")

    message("Master: ", master)
    if (length(list(...)) > 0)
        warning("Arguments ignored: ", paste(names(list(...)), collapse=", "))

    # connect to master
    if (is.null(context))
        w = methods::new(CMQWorker)
    else
        w = methods::new(CMQWorker, context)
    message("connecting to: ", master)
    w$connect(master, 10000L)

    counter = 0
    repeat {
        tic = proc.time()
        w$poll()
        delta = proc.time() - tic
        counter = counter + 1
        message(sprintf("> call %i (%.3fs wait)", counter, delta[3]))
        if (! w$process_one())
            break
    }

    message("shutting down worker")
    run_time = proc.time()
    fmt = "%i in %.2fs [user], %.2fs [system], %.2fs [elapsed]"
    message("\nTotal: ", sprintf(fmt, counter, run_time[1], run_time[2], run_time[3]))
}

#' Queue function calls on the cluster
#'
#' @param fun             A function to call
#' @param ...             Objects to be iterated in each function call
#' @param const           A list of constant arguments passed to each function call
#' @param export          List of objects to be exported to the worker
#' @param pkgs            Character vector of packages to load on the worker
#' @param seed            A seed to set for each function call
#' @param memory          Short for `template=list(memory=value)`
#' @param template        A named list of values to fill in the scheduler template
#' @param n_jobs          The number of jobs to submit; upper limit of jobs if job_size
#'                        is given as well
#' @param job_size        The number of function calls per job
#' @param rettype         Return type of function call (vector type or 'list')
#' @param fail_on_error   If an error occurs on the workers, continue or fail?
#' @param workers         Optional instance of QSys representing a worker pool
#' @param log_worker      Write a log file for each worker
#' @param chunk_size      Number of function calls to chunk together
#'                        defaults to 100 chunks per worker or max. 10 kb per chunk
#' @param timeout         Maximum time in seconds to wait for worker (default: Inf)
#' @param max_calls_worker  Maxmimum number of chunks that will be sent to one worker
#' @param verbose         Print status messages and progress bar (default: TRUE)
#' @return                A list of whatever `fun` returned
#' @export
#'
#' @examples
#' \dontrun{
#' # Run a simple multiplication for numbers 1 to 3 on a worker node
#' fx = function(x) x * 2
#' Q(fx, x=1:3, n_jobs=1)
#' # list(2,4,6)
#'
#' # Run a mutate() call in dplyr on a worker node
#' iris %>%
#'     mutate(area = Q(`*`, e1=Sepal.Length, e2=Sepal.Width, n_jobs=1))
#' # iris with an additional column 'area'
#' }
Q = function(fun, ..., const=list(), export=list(), pkgs=c(), seed=128965,
        memory=NULL, template=list(), n_jobs=NULL, job_size=NULL,
        rettype="list", fail_on_error=TRUE, workers=NULL, log_worker=FALSE,
        chunk_size=NA, timeout=Inf, max_calls_worker=Inf, verbose=TRUE) {

    df = check_args(fun, list(...), const)

    Q_rows(fun = fun,
           df = df,
           const = const,
           export = export,
           pkgs = pkgs,
           seed = seed,
           memory = memory,
           template = template,
           n_jobs = n_jobs,
           job_size = job_size,
           rettype = rettype,
           fail_on_error = fail_on_error,
           workers = workers,
           log_worker = log_worker,
           chunk_size = chunk_size,
           timeout = timeout,
           max_calls_worker = max_calls_worker,
           verbose = verbose)
}

#' Evaluate Function Calls on HPC Schedulers (LSF, SGE, GCS, OCS, SLURM)
#'
#' Provides the \code{Q} function to send arbitrary function calls to
#' workers on HPC schedulers without relying on network-mounted storage.
#' Allows using remote schedulers via SSH.
#'
#' Under the hood, this will submit a cluster job that connects to the master
#' via TCP the master will then send the function and argument chunks to the
#' worker and the worker will return the results to the master until everything
#' is done and you get back your result
#'
#' Computations are done entirely on the network and without any temporary
#' files on network-mounted storage, so there is no strain on the file system
#' apart from starting up R once per job. This removes the biggest bottleneck
#' in distributed computing.
#'
#' Using this approach, we can easily do load-balancing, i.e. workers that get
#' their jobs done faster will also receive more function calls to work on. This
#' is especially useful if not all calls return after the same time, or one
#' worker has a high load.
#'
#' For more detailed usage instructions, see the documentation of the \code{Q}
#' function.
#'
#' @docType package
#' @keywords internal
#' @useDynLib clustermq
#' @import Rcpp
"_PACKAGE"

#' Placeholder for local processing
#'
#' Mainly so tests pass without setting up a scheduler
#'
#' @keywords internal
LOCAL = R6::R6Class("LOCAL",
    inherit = QSys,

    public = list(
        initialize = function(addr="unused", n_jobs=0, master=NULL, ...,
                              log_worker=FALSE, log_file=NULL, verbose=TRUE) {
            super$initialize(addr=addr, master=master)
            if (verbose)
                message("Running sequentially ('LOCAL') ...")
            private$is_cleaned_up = TRUE
        }
    ),

    cloneable = FALSE
)

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

has_connectivity <- function(host) {
    .Call('_clustermq_has_connectivity', PACKAGE = 'clustermq', host)
}

libzmq_has_draft <- function() {
    .Call('_clustermq_libzmq_has_draft', PACKAGE = 'clustermq')
}

alloc_non_r_bytes <- function(n_bytes) {
    .Call('_clustermq_alloc_non_r_bytes', PACKAGE = 'clustermq', n_bytes)
}

context("queue")

skip_if_not(has_connectivity("127.0.0.1"))

test_that("control flow", {
    skip_on_os("windows")
    fx = function(x) x*2
    w = workers(n_jobs=1, qsys_id="multicore", reuse=FALSE)
    r = Q(fx, x=1:3, workers=w, timeout=10L)
    expect_equal(r, as.list(1:3*2))
})

test_that("control flow with automatic workers", {
    skip_on_os("windows")

    old_sched = getOption("clustermq.scheduler")
    on.exit(options(clustermq.scheduler = old_sched))
    options(clustermq.scheduler = "multicore")

    fx = function(x) x*2
    r = Q(fx, x=1:3, n_jobs=1, timeout=10L)
    expect_equal(r, as.list(1:3*2))
})

test_that("common data", {
    skip_on_os("windows")
    fx = function(x, y) x*2 + y
    w = workers(n_jobs=1, qsys_id="multicore", reuse=FALSE)
    r = Q(fx, x=1:3, const=list(y=10), workers=w, timeout=10L)
    expect_equal(r, as.list(1:3*2+10))
})

test_that("export", {
    skip_on_os("windows")
    fx = function(x) x*2 + z
    w = workers(n_jobs=1, qsys_id="multicore", reuse=FALSE)
    r = Q(fx, x=1:3, export=list(z=20), workers=w, timeout=10L)
    expect_equal(r, as.list(1:3*2+20))
})

test_that("load package on worker", {
    skip_on_os("windows")
    fx = function(x) splitIndices(1,1)
    x = "a string"
    w = workers(n_jobs=1, qsys_id="multicore", reuse=FALSE)
    r = Q(fx, x=x, pkgs="parallel", workers=w, rettype="character", timeout=10L)
    expect_equal(r, "1")
})

test_that("seed reproducibility", {
    skip_on_os("windows")
    fx = function(x) sample(1:100, 1)
    w1 = workers(n_jobs=1, qsys_id="multicore", reuse=FALSE)
    w2 = workers(n_jobs=1, qsys_id="multicore", reuse=FALSE)
    r1 = Q(fx, x=1:3, workers=w1, timeout=10L)
    r2 = Q(fx, x=1:3, workers=w2, timeout=10L)
    expect_equal(r1, r2)
})

test_that("master does not exit loop prematurely", {
    skip_on_os("windows")
    fx = function(x) {
        Sys.sleep(0.5)
        x*2
    }
    w = workers(n_jobs=2, qsys_id="multicore", reuse=FALSE)
    r = Q(fx, x=1:3, workers=w, timeout=10L)
    expect_equal(r, as.list(1:3*2))
})

test_that("rettype is respected", {
    skip_on_os("windows")
    fx = function(x) x*2
    w = workers(n_jobs=1, qsys_id="multicore", reuse=FALSE)
    r = Q(fx, x=1:3, rettype="numeric", workers=w, timeout=10L)
    expect_equal(r, 1:3*2)
})

test_that("worker timeout throws error", {
    skip_on_os("windows")
    w = workers(n_jobs=1, qsys_id="multicore", reuse=FALSE)
    expect_error(expect_warning(
        Q(Sys.sleep, 3, rettype="numeric", workers=w, timeout=1L)))
})

test_that("Q with expired workers throws error quickly", {
    skip_on_cran()
    skip_on_os("windows")

    w = workers(n_jobs=1, qsys_id="multicore", reuse=FALSE)
    w$cleanup()

    times = system.time({
        expect_error(Q(identity, x=1:3, rettype="numeric", workers=w, timeout=10L))
    })
    expect_true(times[["elapsed"]] < 5)
})

test_that("shutdown monitor does not fire on clean disconnects", {
    skip_on_os("windows")
    skip_if_not(libzmq_has_draft())

    w = workers(n_jobs=2, qsys_id="multicore", reuse=FALSE)
    res = Q(Sys.sleep, time=c(0,1), workers=w, timeout=10L)
    expect_equal(res, list(NULL, NULL))
})

test_that("max_calls_worker is respected", {
    skip_on_cran()
    skip_on_os("windows")

    fx = function(x) { Sys.sleep(x==1); Sys.getpid() }

    w = workers(n_jobs=2, qsys_id="multicore", reuse=FALSE)
    res = table(unlist(Q(fx, x=1:4, workers=w)))
    expect_true(setequal(res, c(1,3)))

    w = workers(n_jobs=2, qsys_id="multicore", reuse=FALSE)
    res = table(unlist(Q(fx, x=1:4, workers=w, max_calls_worker=2)))
    expect_true(setequal(res, 2))
})

#' LSF scheduler functions
#'
#' Derives from QSys to provide LSF-specific functions
#'
#' @keywords internal
LSF = R6::R6Class("LSF",
    inherit = QSys,

    public = list(
        initialize = function(addr, n_jobs, master, ..., template=getOption("clustermq.template", "LSF"),
                              log_worker=FALSE, log_file=NULL, verbose=TRUE) {
            super$initialize(addr=addr, master=master, template=template)

            opts = private$fill_options(n_jobs=n_jobs, ...)
            private$job_id = opts$job_name
            if (!is.null(opts$log_file))
                opts$log_file = normalizePath(opts$log_file, mustWork=FALSE)
            else if (log_worker)
                opts$log_file = paste0(private$job_id, "-%I.log")
            filled = fill_template(private$template, opts,
                                   required=c("master", "job_name", "n_jobs"))

            if (verbose)
                message("Submitting ", n_jobs, " worker jobs to ", class(self)[1],
                        " as ", sQuote(private$job_id), " ...")

            status = system("bsub", input=filled, ignore.stdout=TRUE)
            if (status != 0)
                private$template_error("LSF", status, filled)
            private$master$add_pending_workers(n_jobs)
            private$is_cleaned_up = FALSE
        },

        cleanup = function(success, timeout) {
            private$is_cleaned_up = success
            private$finalize()
        }
    ),

    private = list(
        job_id = NULL,

        finalize = function(quiet=self$workers_running == 0) {
            quiet = FALSE #TODO:
            if (!private$is_cleaned_up) {
                system(paste("bkill -J", private$job_id),
                       ignore.stdout=quiet, ignore.stderr=quiet, wait=FALSE)
            }
            private$is_cleaned_up = TRUE
        }
    ),

    cloneable = FALSE
)

#' Process on multiple processes on one machine
#'
#' Derives from QSys to provide callr-specific functions
#'
#' @keywords internal
MULTIPROCESS = R6::R6Class("MULTIPROCESS",
    inherit = QSys,

    public = list(
        initialize = function(addr, n_jobs, master, ..., log_worker=FALSE, log_file=NULL, verbose=TRUE) {
            if (! requireNamespace("callr", quietly=TRUE))
                stop("The ", sQuote(callr), " package is required for ", sQuote("multiprocess"))
            addr = sub(Sys.info()["nodename"], "127.0.0.1", addr, fixed=TRUE)
            super$initialize(addr=addr, master=master)

            if (verbose)
                message("Starting ", n_jobs, " processes ...")

            if (log_worker && is.null(log_file))
                log_file = sprintf("cmq%i-%%i.log", private$port)

            for (i in seq_len(n_jobs)) {
                if (is.character(log_file))
                    log_i = suppressWarnings(sprintf(log_file, i))
                else
                    log_i = nullfile()
                cr = callr::r_bg(function(m) clustermq:::worker(m),
                                 args=list(m=private$addr),
                                 stdout=log_i, stderr=log_i)
                private$callr[[as.character(cr$get_pid())]] = cr
            }
            private$master$add_pending_workers(n_jobs)
            private$workers_total = n_jobs
            private$is_cleaned_up = FALSE
        },

        cleanup = function(success, timeout) {
            dead_workers = sapply(private$callr, function(x) ! x$is_alive())
            if (length(dead_workers) > 0)
                private$callr[dead_workers] = NULL
            else
                private$is_cleaned_up = TRUE
            private$is_cleaned_up
        }
    ),

    private = list(
        callr = list(),

        finalize = function(quiet=FALSE) {
            if (!private$is_cleaned_up) {
                dead_workers = sapply(private$callr, function(x) ! x$is_alive())
                if (length(dead_workers) > 0)
                    private$callr[dead_workers] = NULL
                if (!quiet && length(private$callr) > 0)
                    warning("Unclean shutdown for PIDs: ",
                            paste(names(private$callr), collapse=", "), immediate.=TRUE)
                for (cr in private$callr)
                    cr$kill_tree()
            }
            private$is_cleaned_up = TRUE
        }
    ),

    cloneable = FALSE
)

#' Process on multiple cores on one machine
#'
#' Derives from QSys to provide multicore-specific functions
#'
#' @keywords internal
MULTICORE = R6::R6Class("MULTICORE",
    inherit = QSys,

    public = list(
        initialize = function(addr, n_jobs, master, ..., log_worker=FALSE, log_file=NULL, verbose=TRUE) {
            addr = sub(Sys.info()["nodename"], "127.0.0.1", addr, fixed=TRUE)
            super$initialize(addr=addr, master=master)
            if (verbose)
                message("Starting ", n_jobs, " cores ...")
            if (log_worker && is.null(log_file))
                log_file = sprintf("cmq%i-%%i.log", private$port)

            for (i in seq_len(n_jobs)) {
                if (is.character(log_file))
                    log_i = suppressWarnings(sprintf(log_file, i))
                else
                    log_i = nullfile()
                wrapper = function(m, logfile) {
                    fout = file(logfile, open="wt")
                    sink(file=fout, type="output")
                    sink(file=fout, type="message")
                    on.exit({ sink(type="message"); sink(type="output"); close(fout) })
                    clustermq:::worker(m)
                }
                p = parallel::mcparallel(quote(wrapper(private$addr, log_i)))
                private$children[[as.character(p$pid)]] = p
            }
            private$master$add_pending_workers(n_jobs)
            private$workers_total = n_jobs
            private$is_cleaned_up = FALSE
        },

        cleanup = function(success, timeout=5L) {
            private$is_cleaned_up = success
            private$collect_children(wait=FALSE, timeout=timeout)
            private$finalize()
        }
    ),

    private = list(
        collect_children = function(...) {
            pids = as.integer(names(private$children))
            res = suppressWarnings(parallel::mccollect(pids, ...))
            finished = intersect(names(private$children), names(res))
            private$children[finished] = NULL
        },

        children = list(),

        finalize = function(quiet=FALSE) {
            if (!private$is_cleaned_up) {
                private$collect_children(wait=FALSE, timeout=0)
                running = names(private$children)
                if (length(running) > 0) {
                    if (!quiet)
                        warning("Unclean shutdown for PIDs: ",
                                paste(running, collapse=", "),
                                immediate.=TRUE)
                    tools::pskill(running, tools::SIGKILL)
                }
                private$children = list()
            }
            private$is_cleaned_up = TRUE
        }
    ),

    cloneable = FALSE
)

#' Creates a pool of workers
#'
#' @param n_jobs      Number of jobs to submit (0 implies local processing)
#' @param data        Set common data (function, constant args, seed)
#' @param reuse       Whether workers are reusable or get shut down after call
#' @param template    A named list of values to fill in template
#' @param log_worker  Write a log file for each worker
#' @param qsys_id     Character string of QSys class to use
#' @param verbose     Print message about worker startup
#' @param ...         Additional arguments passed to the qsys constructor
#' @return            An instance of the QSys class
#' @export
workers = function(n_jobs, data=NULL, reuse=TRUE, template=list(), log_worker=FALSE,
                   qsys_id=getOption("clustermq.scheduler", qsys_default),
                   verbose=FALSE, ...) {
    if (n_jobs == 0)
        qsys_id = "LOCAL"

    gc() # be sure to clean up old zmq handles (zeromq/libzmq/issues/1108)

    qsys = get(toupper(qsys_id), envir=parent.env(environment()))

    p = Pool$new(reuse=reuse)
#    p$add(qsys, n_jobs, log_worker=log_worker, verbose=verbose, ...)
    args = c(list(qsys=qsys, n=n_jobs, log_worker=log_worker, verbose=verbose), template, list(...))
    do.call(p$add, args)
    p
}

#' Subset index chunk for processing
#'
#' 'attr' in `[.data.frame` takes too much CPU time
#'
#' @param x  Index data.frame
#' @param i  Rows to subset
#' @return   x[i,]
#' @keywords  internal
chunk = function(x, i) {
    re = lapply(x, `[`, i=i)
    re$` id ` = i
    re
}

#!/bin/sh

cd "$(dirname $0)"/..

# the tarball has the submodules, a fresh clone does not
if [ ! -f libzmq/autogen.sh ]; then
  git submodule update --init --recursive
fi

cd libzmq

# remove code format helper and valgrind support that CRAN complains about
# sed -i does not work on macOS
if [ ! -f src/Makefile.am.orig ]; then
  mv Makefile.am Makefile.am.orig
  sed '/WITH_CLANG_FORMAT/,/VALGRIND_SUPPRESSIONS_FILES/d' Makefile.am.orig > Makefile.am
fi

# remove disabled gcc check that cran complains about
if [ ! -f src/curve_client_tools.hpp.orig ]; then
  mv src/curve_client_tools.hpp src/curve_client_tools.hpp.orig
  sed '/^#pragma/s|^|//|' src/curve_client_tools.hpp.orig > src/curve_client_tools.hpp
fi
if [ ! -f include/zmq_utils.h.orig ]; then
  mv include/zmq_utils.h include/zmq_utils.h.orig
  sed '/^#pragma/s|^|//|' include/zmq_utils.h.orig > include/zmq_utils.h
fi

#!/bin/sh

cd "$(dirname $0)"/../libzmq

if [ ! -f Makefile.in ]; then
  ./autogen.sh || exit 1
fi

if [ ! -f src/.libs/libzmq.a ]; then
  CXX="$CXX" CXXFLAGS="$CXXFLAGS -fPIC" CPPFLAGS="$CPPFLAGS" ./configure \
    --enable-drafts \
    --enable-static \
    --disable-shared \
    --disable-maintainer-mode \
    --disable-Werror \
    --disable-libbsd \
    --disable-libunwind \
    --disable-perf \
    --disable-curve \
    --disable-curve-keygen \
    --disable-ws \
    --disable-radix-tree \
    --without-docs
  make || exit 1
fi

---
title: "Technical Documentation"
output:
  rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Technical Documentation}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{css echo=FALSE}
img {
    border: 0px !important;
    margin: 2em 2em 2em 2em !important;
}
code {
    border: 0px !important;
}
```

```{r echo=FALSE, results="hide"}
knitr::opts_chunk$set(
    cache = FALSE,
    echo = TRUE,
    collapse = TRUE,
    comment = "#>"
)
options(clustermq.scheduler = "local")
suppressPackageStartupMessages(library(clustermq))
```

## Worker API

### Base API and schedulers

The main worker functions are wrapped in an _R6_ class with the name of `QSys`.
This provides a standardized API to the [lower-level
messages](https://mschubert.github.io/clustermq/articles/technicaldocs.html#zeromq-message-specification)
that are sent via [_ZeroMQ_](https://zeromq.org/).

The base class itself is derived in scheduler classes that add the required
functions for submitting and cleaning up jobs:

```
+ QSys
  |- Multicore
  |- LSF
  + SGE
    |- GCS
    |- OCS
    |- PBS
    |- Torque
  |- etc.
```

The user-visible object is a worker `Pool` that wraps this, and will eventually
allow to manage different workers.

### Workers

#### Creating a worker pool

A pool of workers can be created using the `workers()` function, which
instantiates a `Pool` object of the corresponding `QSys`-derived scheduler
class. See `?workers` for details.

```{r eval=FALSE}
# start up a pool of three workers using the default scheduler
w = workers(n_jobs=3)

# if we make an unclean exit for whatever reason, clean up the jobs
on.exit(w$cleanup())
```

#### Worker startup

For workers that are started up via a scheduler, we do not know which machine
they will run on. This is why we start up every worker with a TCP/IP address of
the master socket that will distribute work.

This is achieved by the call to R common to all schedulers:

```{sh eval=FALSE}
R --no-save --no-restore -e 'clustermq:::worker("{{ master }}")'
```

#### Worker communication

On the master's side, we wait until a worker connects:

```{r eval=FALSE}
msg = w$recv() # this will block until a worker is ready
```

We can then send any expression to be evaluated on the worker using the `send`
method:

```{r eval=FALSE}
w$send_eval(expression, ...)
```

After the expression (in `...`), any variables that should be passed along with
the call can be added. For batch processing that `clustermq` usually does, this
command is `work_chunk`, where the `chunk` data is added:

```{r eval=FALSE}
w$send(clustermq:::work_chunk(chunk, fun, const, rettype, common_seed),
       chunk = chunk(iter, submit_index))
```

#### Worker environment

We can add any number of objects to a worker environment using the `env`
method:

```{r eval=FALSE}
w$env(object=value, ...)
```

This will also invisibly return a `data.frame` with all objects currently in
the environment. If a user wants to inspect the environment without changing it
they can call `w$env()` without arguments. The environment will be propagated
to all workers automatically in a greedy fashion.

### Main event loop

Putting the above together in an event loop, we get what is essentially
implemented in `master`. `w$send_eval` invisibly returns an identifier to track
which call was submitted, and `w$current()` matches the same to `w$recv()`.

```{r eval=FALSE}
w = workers(3)
on.exit(w$cleanup())
w$env(...)

while (we have new work to send || jobs pending) {
    res = w$recv() # the result of the call, or NULL for a new worker
    # handle result

    if (more work)
        call_ref = w$send_eval(expression, ...) # call_ref tracks request identity
    else
        w$send_shutdown()
}
```

A loop of a similar structure can be used to extend `clustermq`. As an example,
[this was done by the _targets_
package](https://github.com/ropensci/targets/blob/1.2.2/R/class_clustermq.R).

## ZeroMQ message specification

Communication between the `master` (main event loop) and workers (`QSys` base
class) is organised in _messages_. These are chunks of serialized data sent via
_ZeroMQ_'s protocol (_ZMTP_). The parts of each message are called *frames*.

### Master - Worker communication

The master requests an evaluation in a message with X frames (direct) or Y if
proxied. This is all handled by _clustermq_ internally.

* The worker identity frame or routing identifier
* A delimiter frame
* Worker status (`wlife_t`)
* The call to be evaluated
* _N_ repetitions of:
  * The variable name of an environment object that is not yet present on the
    worker
  * The variable value

If using a proxy, this will be followed by a `SEXP` that contains variable
names the proxy should add before forwarding to the worker.

### Worker evaluation

A worker evaluates the call using the R C API:

```{r eval=FALSE}
R_tryEvalSilent(cmd, env, &err);
```

If an error occurs in this evaluation will be returned as a structure with
class `worker_error`. If a developer wants to catch errors and warnings in a
more fine-grained manner, it is recommended to add their own `callingHandlers`
to `cmd` (as _clustermq_ does work its `work_chunk`).

### Worker - Master communication

The result of this evaluation is then returned in a message with four (direct)
or five (proxied) frames:

* Worker identity frame (handled internally by _ZeroMQ_'s `ZMQ_REQ` socket)
* Empty frame (handled internally by _ZeroMQ_'s `ZMQ_REQ` socket)
* Worker status (`wlife_t`) that is handled internally by _clustermq_
* The result of the call (`SEXP`), visible to the user

If using a worker via SSH, these frames will be preceded by a routing identify
frame that is handled internally by _ZeroMQ_ and added or peeled off by the
proxy.

---
title: "User Guide"
output:
  rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{User Guide}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{css echo=FALSE}
img {
    border: 0px !important;
    margin: 2em 2em 2em 2em !important;
}
code {
    border: 0px !important;
}
```

```{r echo=FALSE, results="hide"}
knitr::opts_chunk$set(
    cache = FALSE,
    echo = TRUE,
    collapse = TRUE,
    comment = "#>"
)
options(clustermq.scheduler = "local")
suppressPackageStartupMessages(library(clustermq))
```

## Installation

Install the `clustermq` package in R from CRAN. This will automatically detect
if [ZeroMQ](https://github.com/zeromq/libzmq) is installed and otherwise use
the bundled library:

```{r eval=FALSE}
# Recommended:
#   If your system has `libzmq` installed but you want to enable the worker
#   crash monitor, set the environment variable below to use the bundled
#   `libzmq` library with the required feature (`-DZMQ_BUILD_DRAFT_API=1`):
Sys.setenv(CLUSTERMQ_AUTO_LIBZMQ=1)
install.packages("clustermq")
```

Alternatively you can use the `remotes` package to install directly from
Github. Note that this version needs `autoconf`/`automake` and `CMake` for
compilation:

```{r eval=FALSE}
if (!requireNamespace("remotes", quietly=TRUE))
    install.packages("remotes")
Sys.setenv(CLUSTERMQ_AUTO_LIBZMQ=1)
remotes::install_github("mschubert/clustermq")
# remotes::install_github("mschubert/clustermq@develop") # dev version
```

In the [`develop`](https://github.com/mschubert/clustermq/tree/develop) branch,
we will introduce code changes and new features. These may contain bugs, poor
documentation, or other inconveniences. This branch may not install at times.
However, [feedback is very
welcome](https://github.com/mschubert/clustermq/issues/new).

For any installation issues please see the
[FAQ](https://mschubert.github.io/clustermq/articles/faq.html).

## Configuration

An HPC cluster's scheduler ensures that computing jobs are distributed to
available worker nodes. Hence, this is what `clustermq` interfaces with in
order to do computations.

By default, we will take whichever scheduler we find and fall back on local
processing. This will work in most, but not all cases. You may need to
configure your scheduler.

### Setting up the scheduler {#scheduler-setup}

To set up a scheduler explicitly, see the following links:

* [SLURM](#slurm) - *should work without setup*
* [LSF](#lsf) - *should work without setup*
* [SGE](#sge) - *may require configuration*
* [GCS](#gcs)/[OCS](#ocs) - *needs* `options(clustermq.scheduler="GCS"/"OCS")`
* [PBS](#pbs)/[Torque](#torque) - *needs* `options(clustermq.scheduler="PBS"/"Torque")`
* you can suggest another scheduler by [opening an
  issue](https://github.com/mschubert/clustermq/issues)

You may in addition need to activate [compute environments or
containers](#environments) if your shell (_e.g._ `~/.bashrc`) does not do this
automatically.

Check the
[FAQ](https://mschubert.github.io/clustermq/articles/faq.html) if your
job submission/call to `Q` errors or gets stuck.

### Local parallelization

While this is not the main focus of the package, you can use it to parallelize
function calls locally on multiple cores or processes. This can also be useful
to test your code on a subset of the data before submitting it to a scheduler.

* Multiprocess (*recommended*) - Use the `callr` package to run and manage
  multiple parallel R processes with `options(clustermq.scheduler="multiprocess")`
* Multicore - Uses the `parallel` package to fork the current R process into
  multiple threads with `options(clustermq.scheduler="multicore")`. This
  sometimes causes problems (macOS, RStudio) and is not available on Windows.

### SSH connector

There are reasons why you might prefer to not to work on the computing cluster
directly but rather on your local machine instead.
[RStudio](https://posit.co/products/open-source/rstudio) is an excellent local
IDE, it's more responsive than and feature-rich than browser-based solutions
([RStudio server](https://posit.co/products/open-source/rstudio-server),
[Project Jupyter](https://jupyter.org/)), and it avoids X forwarding issues
when you want to look at plots you just made.

Using this setup, however, you lost access to the computing cluster. Instead,
you had to copy your data there, and then submit individual scripts as jobs,
aggregating the data in the end again. `clustermq` is trying to solve this by
providing a transparent SSH interface.

In order to use `clustermq` from your local machine, the package needs to be
installed on both there and on the computing cluster. On the computing cluster,
[set up your scheduler](#scheduler-setup) and make sure `clustermq` runs there
without problems. Note that the *remote scheduler* can not be `LOCAL` (default
if no HPC scheduler found) or `SSH` for this to work.

```{r eval=FALSE}
# If this is set to 'LOCAL' or 'SSH' you will get the following error:
#  Expected PROXY_READY, received ‘PROXY_ERROR: Remote SSH QSys is not allowed’
options(
    clustermq.scheduler = "multiprocess" # or multicore, LSF, SGE, Slurm etc.
)
```

On your *local machine*, add the following options:

```{r eval=FALSE}
options(
    clustermq.scheduler = "ssh",
    clustermq.ssh.host = "user@host", # use your user and host, obviously
    clustermq.ssh.log = "~/cmq_ssh.log" # log for easier debugging
)
```

We recommend that you [set up SSH keys](https://www.digitalocean.com/community/tutorials/how-to-configure-ssh-key-based-authentication-on-a-linux-server) for password-less login.

## Usage

### The `Q` function

The following arguments are supported by `Q`:

 * `fun` - The function to call. This needs to be self-sufficient (because it
        will not have access to the `master` environment)
 * `...` - All iterated arguments passed to the function. If there is more than
        one, all of them need to be named
 * `const` - A named list of non-iterated arguments passed to `fun`
 * `export` - A named list of objects to export to the worker environment

Behavior can further be fine-tuned using the options below:

 * `fail_on_error` - Whether to stop if one of the calls returns an error
 * `seed` - A common seed that is combined with job number for reproducible results
 * `memory` - Amount of memory to request for the job (`bsub -M`)
 * `n_jobs` - Number of jobs to submit for all the function calls
 * `job_size` - Number of function calls per job. If used in combination with
        `n_jobs` the latter will be overall limit
 * `chunk_size` - How many calls a worker should process before reporting back
        to the master. Default: every worker will report back 100 times total

The full documentation is available by typing `?Q`.

### Examples

The package is designed to distribute arbitrary function calls on HPC worker
nodes. There are, however, a couple of caveats to observe as the R session
running on a worker does not share your local memory.

The simplest example is to a function call that is completely self-sufficient,
and there is one argument (`x`) that we iterate through:

```{r}
fx = function(x) x * 2
Q(fx, x=1:3, n_jobs=1)
```

Non-iterated arguments are supported by the `const` argument:

```{r}
fx = function(x, y) x * 2 + y
Q(fx, x=1:3, const=list(y=10), n_jobs=1)
```

If a function relies on objects in its environment that are not passed as
arguments (including other functions), they can be exported using the `export` argument:

```{r}
fx = function(x) x * 2 + y
Q(fx, x=1:3, export=list(y=10), n_jobs=1)
```

If we want to use a package function we need to load it on the worker using the
`pkgs` parameter, or referencing it with `package_name::`:

```{r}
f1 = function(x) splitIndices(x, 3)
# Q(f1, x=5, n_jobs=1)
# (Error #1) could not find function "splitIndices"

Q(f1, x=3, n_jobs=1, pkgs="parallel")

f2 = function(x) parallel::splitIndices(x, 3)
Q(f2, x=8, n_jobs=1)
```

### As parallel `foreach` backend

The [`foreach`](https://cran.r-project.org/package=foreach) package provides an
interface to perform repeated tasks on different backends. While it can perform
the function of simple loops using `%do%`:

```{r}
library(foreach)
foreach(i=1:3) %do% sqrt(i)
```

It can also perform these operations in parallel using `%dopar%`:
This operator allows registering different handlers for parallel execution, where
we can use `clustermq`:

```{r}
# set up the scheduler first, otherwise this will run sequentially

# this accepts same arguments as `Q`
# the number of jobs is ignored here since we're using the LOCAL scheduler
clustermq::register_dopar_cmq(n_jobs=2, memory=1024)

# this will be executed as jobs
foreach(i=1:3) %dopar% sqrt(i)
```

As [BiocParallel](https://bioconductor.org/packages/release/bioc/html/BiocParallel.html)
supports `foreach` too, this means we can run all packages that use `BiocParallel`
on the cluster as well via `DoparParam`.

```{r}
library(BiocParallel)

# the number of jobs is ignored here since we're using the LOCAL scheduler
clustermq::register_dopar_cmq(n_jobs=2, memory=1024)
register(DoparParam())
bplapply(1:3, sqrt)
```

### With `targets`

The [`targets`](https://github.com/ropensci/targets) package enables users to
define a dependency structure of different function calls, and only evaluate
them if the underlying data changed.

> The `targets` package is a [Make](https://www.gnu.org/software/make/)-like
> pipeline tool for statistics and data science in R. The package skips costly
> runtime for tasks that are already up to date, orchestrates the necessary
> computation with implicit parallel computing, and abstracts files as R
> objects. If all the current output matches the current upstream code and
> data, then the whole pipeline is up to date, and the results are more
> trustworthy than otherwise.

It can use `clustermq` to [perform calculations as
jobs](https://books.ropensci.org/targets/hpc.html#clustermq).

## Options

The various configurable options are mentioned throughout the documentation,
where applicable, however, we list all of the options here for reference.

Options can be set by including a call to `options(<key> = <value>)` in your
current session or added as a line to your `~/.Rprofile`. The former will only
be available in your active session, while the latter will be available any
time after you restart R.

* `clustermq.scheduler` - One of the supported
      [`clustermq` schedulers](#configuration); options are `"local"`,
      `"multiprocess"`, `"multicore"`, `"lsf"`, `"sge"`, `"gcs"`, `"ocs"`,
      `"slurm"`, `"pbs"`, `"torque"`, or `"ssh"` (default is the HPC scheduler
      found in `$PATH`, otherwise `"local"`)
* `clustermq.host` - The name of the node or device for constructing the
      `ZeroMQ` host address (default is `Sys.info()["nodename"]`)
* `clustermq.ports` - A port range used by `clustermq` to initiate connections.
      (default: `6000:9999`) Important: This option - when used with the ssh
      connector - must be set as an option on the remote host.
* `clustermq.ssh.host` - The user name and host for
      [connecting to the HPC via SSH](#ssh-connector) (e.g. `user@host`); we
      recommend setting up SSH keys for password-less login
* `clustermq.ssh.log` - Path for a file (on the SSH host) that will be created
      and populated with logging information regarding the SSH connection
      (e.g. `"~/cmq_ssh.log"`); helpful for debugging purposes
* `clustermq.ssh.timeout` - The amount of time to wait (in seconds) for a SSH
      start-up connection before timing out (default is `10` seconds)
* `clustermq.ssh.hpc_fwd_port` - Port that will be opened for SSH reverse
      tunneling between the workers on the HPC and a local session. 
      Can also be specified as a port range that clustermq will sample from. 
      (default: one integer randomly sampled from the range between 50000 and
      55000)
* `clustermq.worker.timeout` - The amount of time to wait (in seconds) for
      master-worker communication before timing out (default is to wait
      indefinitely)
* `clustermq.template` - Path to a [template file](#scheduler-templates) for
      submitting HPC jobs; only necessary if using your own template, otherwise
      the default template will be used (default depends on set or inferred
      `clustermq.scheduler`)
* `clustermq.data.warning` - The threshold for the size of the common data (in
      Mb) before `clustermq` throws a warning (default is `1000`)
* `clustermq.defaults` - A named-list of default values for the HPC template;
      this takes precedence over defaults specified in the template file
      (default is an empty list)

## Debugging workers

Function calls evaluated by workers are wrapped in event handlers, which means
that even if a call evaluation throws an error, this should be reported back to
the main R session.

However, there are reasons why workers might crash, and in which case they can
not report back. These include:

* A segfault in a low-level process
* Process kill due to resource constraints (e.g. walltime)
* Reaching the wait timeout without any signal from the master process
* Probably others

In this case, it is useful to have the worker(s) create a log file that will
also include events that are not reported back. It can be requested using:

```{r eval=FALSE}
Q(..., log_worker=TRUE)
```

This will create a file called *&lt;cmq_id&gt;-&lt;array_index&gt;.log* in your current
working directory, irrespective of which scheduler you use.

You can customize the file name using

```{r eval=FALSE}
Q(..., template=list(log_file = <yourlog>))
```

Note that in this case `log_file` is a template field of your scheduler script,
and hence needs to be present there in order for this to work. The default
templates all have this field included.

In order to log each worker separately, some schedulers support wildcards in
their log file names. For instance:

* Multicore/Multiprocess: `log_file="/path/to.file.%i"`
* SGE: `log_file="/path/to.file.$TASK_ID"`
* LSF: `log_file="/path/to.file.%I"`
* Slurm: `log_file="/path/to.file.%a"`
* PBS: `log_file="/path/to.file.$PBS_ARRAY_INDEX"`
* Torque: `log_file="/path/to.file.$PBS_ARRAYID"`

Your scheduler documentation will have more details about the available
options.

When reporting a bug that includes worker crashes, please always include a log
file.

## Environments

In some cases, it may be necessary to activate a specific computing environment
on the scheduler jobs prior to starting up the worker. This can be, for
instance, because *R* was only installed in a specific environment or
container.

Examples for such environments or containers are:

* [Bash module](https://envmodules.io/) environments
* [Conda](https://docs.conda.io/) environments
* [Docker](https://www.docker.com/)/[Singularity](https://singularity.lbl.gov/) containers

It should be possible to activate them in the job submission script (i.e., the
template file). This is widely untested, but would look the following for the
[LSF](#lsf) scheduler (analogous for others):

```{sh eval=FALSE}
#BSUB-J {{ job_name }}[1-{{ n_jobs }}]  # name of the job / array jobs
#BSUB-o {{ log_file | /dev/null }}      # stdout + stderr
#BSUB-M {{ memory | 4096 }}             # Memory requirements in Mbytes
#BSUB-R rusage[mem={{ memory | 4096 }}] # Memory requirements in Mbytes
##BSUB-q default                        # name of the queue (uncomment)
##BSUB-W {{ walltime | 6:00 }}          # walltime (uncomment)

module load {{ bashenv | default_bash_env }}
# or: source activate {{ conda | default_conda_env_name }}
# or: your environment activation command
ulimit -v $(( 1024 * {{ memory | 4096 }} ))
CMQ_AUTH={{ auth }} R --no-save --no-restore -e 'clustermq:::worker("{{ master }}")'
```

This template still needs to be filled, so in the above example you need to
pass either

```{r eval=FALSE}
Q(..., template=list(bashenv="my environment name"))
```

or set it via an option:

```{r eval=FALSE}
options(
    clustermq.defaults = list(bashenv="my default env")
)
```

## Scheduler templates

The package provides its own default scheduler templates, similar to the ones
listed below. Which template is used is decided based on which scheduler
submission executable is present in the user's `$PATH`, e.g. `sbatch` for SLURM
or `bsub` for LSF. `qsub` is ambiguous between SGE and PBS/Torque, so in this
case `options(clustermq.scheduler = "<opt>")` should be set to the correct one.

A user can provide their own template file via `options(clustermq.template =
"<file>")`, containing arbitrary template values `{{ value | default }}`. These
values will be filled upon job submission in the following order of priority:

 1. The argument provided to `Q(..., template=list(key = value))` or
    `workers(... template=list(key = value))`
 2. The value of `getOption("clustermq.defaults")`
 3. The default value inside the template

### LSF

Set the following options in your _R_ session that will submit jobs:

```{r eval=FALSE}
options(
    clustermq.scheduler = "lsf",
    clustermq.template = "/path/to/file/below" # if using your own template
)
```

To supply your own template, save the contents below with any desired changes
to a file and have `clustermq.template` point to it.

```{sh eval=FALSE}
#BSUB-J {{ job_name }}[1-{{ n_jobs }}]  # name of the job / array jobs
#BSUB-n {{ cores | 1 }}                 # number of cores to use per job
#BSUB-o {{ log_file | /dev/null }}      # stdout + stderr; %I for array index
#BSUB-M {{ memory | 4096 }}             # Memory requirements in Mbytes
#BSUB-R rusage[mem={{ memory | 4096 }}] # Memory requirements in Mbytes
##BSUB-q default                        # name of the queue (uncomment)
##BSUB-W {{ walltime | 6:00 }}          # walltime (uncomment)

ulimit -v $(( 1024 * {{ memory | 4096 }} ))
CMQ_AUTH={{ auth }} R --no-save --no-restore -e 'clustermq:::worker("{{ master }}")'
```

In this file, `#BSUB-*` defines command-line arguments to the `bsub` program.

* Memory: defined by `BSUB-M` and `BSUB-R`. Check your local setup if the
  memory values supplied are MiB or KiB, default is `4096` if not requesting
  memory when calling `Q()`
* Queue: `BSUB-q default`. Use the queue with name *default*. This will most
  likely not exist on your system, so choose the right name and uncomment by
  removing the additional `#`
* Walltime: `BSUB-W {{ walltime }}`. Set the maximum time a job is allowed to
  run before being killed. The default here is to disable this line. If you
  enable it, enter a fixed value or pass the `walltime` argument to each
  function call. The way it is written, it will use 6 hours if no arguemnt is
  given.
* For other options, see [the LSF
  documentation](https://www.ibm.com/docs/en/spectrum-lsf/10.1.0?topic=bsub-options)
  and add them via `#BSUB-*` (where `*` represents the argument)
* Do not change the identifiers in curly braces (`{{ ... }}`), as they are used
  to fill in the right variables

Once this is done, the package will use your settings and no longer warn you of
the missing options.


### GCS

Set the following options in your _R_ session that will submit jobs:

```{r eval=FALSE}
options(
    clustermq.scheduler = "gcs",
    clustermq.template = "/path/to/file/below" # if using your own template
)
```

To supply your own template, save the contents below with any desired changes
to a file and have `clustermq.template` point to it.

```{sh eval=FALSE}
# Name of the job visible in GCS
#$ -terse                        # Show job ID
#$ -N {{ job_name }}             # Job name
#$ -j y                          # Combine stdout/stderr into one file
#$ -o {{ log_file | /dev/null }} # Output file
#$ -cwd                          # Use cwd as working directory
#$ -V                            # Export all environment variables to the job
                                 # Depending on security settings might require a
                                 # cluster manager to set ENABLE_SUBMIT_LIB_PATH=1 as
                                 # *qmaster_param* to export *LD_LIBRARY_PATH*
#$ -t 1-{{ n_jobs }}             # Spawns workload as tasks of an array job
#$ -pe mytestpe {{ cores | 1 }}  # Allocate one slot per task
#$ -bunit C                      # Allocate *power core(s)* per slot
#$ -bamount {{ threads | 1 }}    # Allocate *one* power core per slot
#$ -bstrategy packed             # *Pack* cores on a host to share NUMA nodes and caches
#$ -btype host                   # Bind per host
#$ -binstance set                # Use HWLOC to bind cores
## Resource requests and limits (convert memory from Mb to bytes)
#$ -l mem_free=$(( 1024 * 1024 * {{ memory | 4096 }} )),h_rt={{ walltime | 3600 }},q=all.q
#$ -ac application=clustermq,hostname={{ master }} # Tag the job

ulimit -v $(( 1024 * {{ memory | 4096 }} ))
CMQ_AUTH={{ auth }} R --no-save --no-restore -e 'clustermq:::worker("{{ master }}")'
```

In this file, `#$-*` defines command-line arguments to the `qsub` program.

* Used objects (mytestpe, all.q) in the template example are default objects
  available after the default installation of GCS. Adapt the template to your
  local setup if these objects are not available or if you want to use other
  ones.
* The mytestpe is limited to 5 slots as default. Increase as appropriate for
  your cluster and needs.
* For other options, see the [qsub man page](https://github.com/hpc-gridware/clusterscheduler/blob/master/doc/markdown/man/man1/submit.include.md)
* Find more detailed documentation on the options in the GCS manuals part of
  your product installation ($SGE_ROOT/doc/pdf)
* Do not change the identifiers in curly braces (`{{ ... }}`), as they are
  used to fill in the right variables.

Once this is done, the package will use your settings and no longer warn you of
the missing options.


### OCS

Set the following options in your _R_ session that will submit jobs:

```{r eval=FALSE}
options(
    clustermq.scheduler = "ocs",
    clustermq.template = "/path/to/file/below" # if using your own template
)
```

To supply your own template, save the contents below with any desired changes
to a file and have `clustermq.template` point to it.

```{sh eval=FALSE}
# Name of the job visible in OCS
#$ -terse                        # Show job ID
#$ -N {{ job_name }}             # Job name
#$ -j y                          # Combine stdout/stderr into one file
#$ -o {{ log_file | /dev/null }} # Output file
#$ -cwd                          # Use cwd as working directory
#$ -V                            # Export all environment variables to the job
                                 # Depending on security settings might require a
                                 # cluster manager to set ENABLE_SUBMIT_LIB_PATH=1 as
                                 # *qmaster_param* to export *LD_LIBRARY_PATH*
#$ -t 1-{{ n_jobs }}             # Spawns workload as tasks of an array job
#$ -pe mytestpe {{ cores | 1 }}  # Allocate one slot per task
#$ -bunit C                      # Allocate *power core(s)* per slot
#$ -bamount {{ threads | 1 }}    # Allocate *one* power core per slot
## Resource requests and limits (convert memory from Mb to bytes)
#$ -l mem_free=$(( 1024 * 1024 * {{ memory | 4096 }} )),h_rt={{ walltime | 3600 }},q=all.q
#$ -ac application=clustermq,hostname={{ master }} # Tag the job

ulimit -v $(( 1024 * {{ memory | 4096 }} ))
CMQ_AUTH={{ auth }} R --no-save --no-restore -e 'clustermq:::worker("{{ master }}")'
```

In this file, `#$-*` defines command-line arguments to the `qsub` program.

* Used objects (mytestpe, all.q) in the template example are default objects
  available after the default installation of GCS. Adapt the template to your
  local setup if these objects are not available or if you want to use other
  ones.
* The mytestpe is limited to 5 slots as default. Increase as appropriate for
  your cluster and needs.
* For other options, see the [qsub man page](https://github.com/hpc-gridware/clusterscheduler/blob/master/doc/markdown/man/man1/submit.include.md)
* Do not change the identifiers in curly braces (`{{ ... }}`), as they are
  used to fill in the right variables.

Once this is done, the package will use your settings and no longer warn you of
the missing options.

### SGE

Set the following options in your _R_ session that will submit jobs:

```{r eval=FALSE}
options(
    clustermq.scheduler = "sge",
    clustermq.template = "/path/to/file/below" # if using your own template
)
```

To supply your own template, save the contents below with any desired changes
to a file and have `clustermq.template` point to it.

```{sh eval=FALSE}
#$ -N {{ job_name }}               # job name
##$ -q default                      # submit to queue named "default"
#$ -j y                            # combine stdout/error in one file
#$ -o {{ log_file | /dev/null }}   # output file
#$ -cwd                            # use pwd as work dir
#$ -V                              # use environment variable
#$ -t 1-{{ n_jobs }}               # submit jobs as array
#$ -pe smp {{ cores | 1 }}         # number of cores to use per job
#$ -l m_mem_free={{ memory | 1073741824 }} # 1 Gb in bytes

ulimit -v $(( 1024 * {{ memory | 4096 }} ))
CMQ_AUTH={{ auth }} R --no-save --no-restore -e 'clustermq:::worker("{{ master }}")'
```

In this file, `#$-*` defines command-line arguments to the `qsub` program.

* Queue: `$ -q default`. Use the queue with name *default*. This will most
  likely not exist on your system, so choose the right name and uncomment by
  removing the additional `#`
* For other options, see [the SGE
  documentation](https://gridscheduler.sourceforge.net/htmlman/manuals.html). Do
  not change the identifiers in curly braces (`{{ ... }}`), as they are used to
  fill in the right variables.

Once this is done, the package will use your settings and no longer warn you of
the missing options.

### SLURM

Set the following options in your _R_ session that will submit jobs:

```{r eval=FALSE}
options(
    clustermq.scheduler = "slurm",
    clustermq.template = "/path/to/file/below" # if using your own template
)
```

To supply your own template, save the contents below with any desired changes
to a file and have `clustermq.template` point to it.

```{sh eval=FALSE}
#!/bin/sh
#SBATCH --job-name={{ job_name }}
##SBATCH --partition=default
#SBATCH --output={{ log_file | /dev/null }}
#SBATCH --error={{ log_file | /dev/null }}
#SBATCH --mem-per-cpu={{ memory | 4096 }}
#SBATCH --array=1-{{ n_jobs }}
#SBATCH --cpus-per-task={{ cores | 1 }}

ulimit -v $(( 1024 * {{ memory | 4096 }} ))
CMQ_AUTH={{ auth }} R --no-save --no-restore -e 'clustermq:::worker("{{ master }}")'
```

In this file, `#SBATCH` defines command-line arguments to the `sbatch` program.

* Partition: `SBATCH --partition default`. Use the queue with name *default*.
  This will most likely not exist on your system, so choose the right name and
  uncomment by removing the additional `#`
* For other options, see [the SLURM
  documentation](https://slurm.schedmd.com/sbatch.html). Do not change the
  identifiers in curly braces (`{{ ... }}`), as they are used to fill in the
  right variables.

Once this is done, the package will use your settings and no longer warn you of
the missing options.

### PBS

Set the following options in your _R_ session that will submit jobs:

```{r eval=FALSE}
options(
    clustermq.scheduler = "pbs",
    clustermq.template = "/path/to/file/below" # if using your own template
)
```

To supply your own template, save the contents below with any desired changes
to a file and have `clustermq.template` point to it.

```{sh eval=FALSE}
#PBS -N {{ job_name }}
#PBS -J 1-{{ n_jobs }}
#PBS -l select=1:ncpus={{ cores | 1 }}:mpiprocs={{ cores | 1 }}:mem={{ memory | 4096 }}MB
#PBS -l walltime={{ walltime | 12:00:00 }}
#PBS -o {{ log_file | /dev/null }}
#PBS -j oe
##PBS -q default

ulimit -v $(( 1024 * {{ memory | 4096 }} ))
CMQ_AUTH={{ auth }} R --no-save --no-restore -e 'clustermq:::worker("{{ master }}")'
```

In this file, `#PBS-*` defines command-line arguments to the `qsub` program.

* Queue: `#PBS-q default`. Use the queue with name *default*. This will most
  likely not exist on your system, so choose the right name and uncomment by
  removing the additional `#`
* For other options, see the PBS documentation. Do not change the identifiers
  in curly braces (`{{ ... }}`), as they are used to fill in the right
  variables.

Once this is done, the package will use your settings and no longer warn you of
the missing options.

### Torque

Set the following options in your _R_ session that will submit jobs:

```{r eval=FALSE}
options(
    clustermq.scheduler = "Torque",
    clustermq.template = "/path/to/file/below" # if using your own template
)
```

To supply your own template, save the contents below with any desired changes
to a file and have `clustermq.template` point to it.

```{sh eval=FALSE}
#PBS -N {{ job_name }}
#PBS -l nodes={{ n_jobs }}:ppn={{ cores | 1 }},walltime={{ walltime | 12:00:00 }}
#PBS -o {{ log_file | /dev/null }}
#PBS -j oe
##PBS -q default

ulimit -v $(( 1024 * {{ memory | 4096 }} ))
CMQ_AUTH={{ auth }} R --no-save --no-restore -e 'clustermq:::worker("{{ master }}")'
```

In this file, `#PBS-*` defines command-line arguments to the `qsub` program.

* Queue: `#PBS-q default`. Use the queue with name *default*. This will most
  likely not exist on your system, so choose the right name and uncomment by
  removing the additional `#`
* For other options, see the Torque documentation. Do not change the
  identifiers in curly braces (`{{ ... }}`), as they are used to fill in the
  right variables.

Once this is done, the package will use your settings and no longer warn you of
the missing options.

### SSH {#ssh-template}

While SSH is not a scheduler, we can access remote schedulers via SSH. If you
want to use it, first make sure that `clustermq` works on your server with the
real scheduler. Only then move on to setting up SSH.

```{r eval=FALSE}
options(
    clustermq.scheduler = "ssh",
    clustermq.ssh.host = "myhost", # set this up in your local ~/.ssh/config
    clustermq.ssh.log = "~/ssh_proxy.log",     # log file on your HPC
    clustermq.ssh.timeout = 30,    # if changing default connection timeout
    clustermq.template = "/path/to/file/below" # if using your own template
)
```

The default template is shown below. If `R` is not in your HPC `$PATH`, you may
need to specify its path or [load the required bash modules/conda
environments](https://github.com/mschubert/clustermq/issues/281).

To supply your own template, save its contents with any desired changes to a
file _on your local machine_ and have `clustermq.template` point to it.

```{sh eval=FALSE}
ssh -o "ExitOnForwardFailure yes" -f
    -R {{ ctl_port }}:localhost:{{ local_port }}
    -R {{ job_port }}:localhost:{{ fwd_port }}
    {{ ssh_host }}
    "R --no-save --no-restore -e
        'clustermq:::ssh_proxy(ctl={{ ctl_port }}, job={{ job_port }})'
        > {{ ssh_log | /dev/null }} 2>&1"
```

---
title: "Frequently asked questions"
output:
  rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{FAQ}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{css echo=FALSE}
img {
    border: 0px !important;
    margin: 2em 2em 2em 2em !important;
}
code {
    border: 0px !important;
}
```

```{r echo=FALSE, results="hide"}
knitr::opts_chunk$set(
    cache = FALSE,
    echo = TRUE,
    collapse = TRUE,
    comment = "#>"
)
options(clustermq.scheduler = "local", rmarkdown.html_vignette.check_title = FALSE)
suppressPackageStartupMessages(library(clustermq))
```

## Installation errors {#install}

To compile this package a fully C++11 compliant compiler is required. This is
[implicit for CRAN packages](https://tidyverse.org/blog/2023/03/cran-checks-compiled-code/)
since `R=3.6.2` and is hence not listed in _SystemRequirements_.

If you encounter an error saying that that no matching function call to
`zmq::message_t::message_t(std::string&)` exists, your compiler does not
(fully) support this and the automated check failed for some reason.

```{sh eval=FALSE}
In file included from CMQMaster.cpp:2:0:
CMQMaster.h: In member function ‘void CMQMaster::proxy_submit_cmd(SEXP, int)’:
CMQMaster.h:146:40: error: no matching function for call to ‘zmq::message_t::message_t(std::string&)’
         mp.push_back(zmq::message_t(cur));
```

This happens for instance for old versions of the `gcc` compiler (default on
most Linux distributions). You can check your version in the terminal using:

```{sh eval=FALSE}
# the minimum required gcc version is 5.5 for full C++11 support (3.3 for clang)
cc --version
```

In this case, it is _very_ likely that your HPC system already has a newer
compiler installed that you need to add to your `$PATH` or load as a module.
Once this is set, you can install the package from R *that was started in a
terminal that has this module/path active*.

## Session gets stuck at "Running calculations" {#stuck}

Your R session may be stuck at something like the following:

```{r eval=FALSE}
> clustermq::Q(identity, x=42, n_jobs=1)
Submitting 1 worker jobs (ID: cmq8480) ...
Running 1 calculations (5 objs/19.4 Kb common; 1 calls/chunk) ...
```

You will see this every time your jobs are queued but not yet started.
Depending on how busy your HPC is, this may take a long time. You can check the
queueing status of your jobs in the terminal with _e.g._ `qstat` (SGE, GCS or OCS), `bjobs`
(LSF), or `sinfo` (SLURM).

If your jobs are already finished, this likely means that the `clustermq`
workers can not connect to the main session. You can confirm this by passing
[`log_worker=TRUE`](https://mschubert.github.io/clustermq/articles/userguide.html#debugging-workers)
to `Q` and inspect the logs created in your current working directory. If they
state something like:

```{sh eval=FALSE}
> clustermq:::worker("tcp://my.headnode:9091")
2023-12-11 10:22:58.485529 | Master: tcp://my.headnode:9091
2023-12-11 10:22:58.488892 | connecting to: tcp://my.headnode:9091:
Error: Connection failed after 10016 ms
Execution halted
```

the submitted job is indeed unable to establish a network connection with the
head node. This can happen if your HPC does not allow incoming connections at
all, but more likely happens because (1) only certain ports are allowed, or (2)
there are multiple network interfaces, only some of which have access to the
head node.

 1. If the head node only allows incoming connections on certain ports, set the
    [R
    option](https://mschubert.github.io/clustermq/articles/userguide.html#options)
    `clustermq.ports=<port range>`.
 2. You can list the available network interfaces using the `ifconfig` command
    in the terminal. Find the interface that shares a subnetwork with the head
    node and add the [R
    option](https://mschubert.github.io/clustermq/articles/userguide.html#options)
    `clustermq.host=<interface>`. If this is unclear, contact your system
    administrators to see which interface to use.

## SSH not working {#ssh}

Before trying remote schedulers via SSH, make sure that the scheduler works
when you first connect to the cluster and run a job from there.

If the terminal is stuck at

```
Connecting <user@host> via SSH ...
```

make sure that each step of your SSH connection works by typing the following
commands in your **local** terminal and make sure that you don't get errors or
warnings in each step:

```{sh eval=FALSE}
# test your ssh login that you set up in ~/.ssh/config
# if this fails you have not set up SSH correctly
ssh <user@host>

# test port forwarding from 54709 remote to 6687 local (ports are random)
# if the fails you will not be able to use clustermq via SSH
ssh -R 54709:localhost:6687 <user@host> R --vanilla
```

If you get an `Command not found: R` error, make sure your `$PATH` is set up
correctly in your `~/.bash_profile` and/or your `~/.bashrc` (depending on your
cluster config you might need either). You may also need to modify your [SSH
template](https://mschubert.github.io/clustermq/articles/userguide.html#ssh-template)
to load R as a module or conda environment.

If you get a SSH warning or error try again with `ssh -v` to enable verbose
output. If the forward itself works, run the following in your local R session
(ideally also in command-line R, [not only in
RStudio](https://github.com/mschubert/clustermq/issues/206)):

```{r eval=FALSE}
options(clustermq.scheduler = "ssh",
        clustermq.ssh.log = "~/ssh_proxy.log")
Q(identity, x=1, n_jobs=1)
```

This will create a log file *on the remote server* that will contain any errors
that might have occurred during `ssh_proxy` startup.

If the `ssh_proxy` startup fails on your local machine with the error

```
Remote R process did not respond after 5 seconds. Check your SSH server log.
```

but the server log does not show any errors, then you can try increasing the
timeout:

```{r eval=FALSE}
options(clustermq.ssh.timeout = 30) # in seconds
```

This can happen when your SSH startup template includes additional steps before
starting R, such as activating a module or conda environment, or having to
confirm the connection via two-factor authentication.

## Running the master inside containers {#master-in-container}

If your master process is inside a container, accessing the HPC scheduler is
more difficult. Containers, including singularity and docker, isolate the
processes inside the container from the host. The *R* process will not be able
to submit a job because the scheduler cannot be found.

Note that the HPC node running the master process must be allowed to submit
jobs. Not all HPC systems allow compute nodes to submit jobs. If that is the
case, you may need to run the master process on the login node, and discuss the
issue with your system administrator.

If your container is binary compatible with the host, you may be able to bind
in the scheduler executable to the container.

For example, PBS might look something like:

```{sh eval=FALSE}
#PBS directives ...

module load singularity

SINGULARITYENV_APPEND_PATH=/opt/pbs/bin
singularity exec --bind /opt/pbs/bin r_image.sif Rscript master_script.R
```

A working example of binding SLURM into a CentOS 7 container image from a
CentOS 7 host is available at
https://groups.google.com/a/lbl.gov/d/msg/singularity/syLcsIWWzdo/NZvF2Ud2AAAJ

Alternatively, you can create a script that uses SSH to execute the scheduler
on the login node. For this, you will need an SSH client in the container,
[keys set up for password-less login](https://www.digitalocean.com/community/tutorials/how-to-configure-ssh-key-based-authentication-on-a-linux-server),
and create a script to call the scheduler on the login node via ssh (e.g.
`~/bin/qsub` for SGE/GCS/OCS/PBS/Torque, `bsub` for LSF and `sbatch` for Slurm):

```{sh eval=FALSE}
#!/bin/bash
ssh -i ~/.ssh/<your key file> ${PBS_O_HOST:-"no_host_not_in_a_pbs_job"} qsub "$@"
```

Make sure the script is executable, and bind/copy it into the container
somewhere on `$PATH`. Home directories are bound in by default in singularity.

```{sh eval=FALSE}
chmod u+x ~/bin/qsub
SINGULARITYENV_APPEND_PATH=~/bin
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/master.r
\name{master}
\alias{master}
\title{Master controlling the workers}
\usage{
master(
  pool,
  iter,
  rettype = "list",
  fail_on_error = TRUE,
  chunk_size = NA,
  timeout = Inf,
  max_calls_worker = Inf,
  verbose = TRUE
)
}
\arguments{
\item{pool}{Instance of Pool object}

\item{iter}{Objects to be iterated in each function call}

\item{rettype}{Return type of function}

\item{fail_on_error}{If an error occurs on the workers, continue or fail?}

\item{chunk_size}{Number of function calls to chunk together
defaults to 100 chunks per worker or max. 500 kb per chunk}

\item{timeout}{Maximum time in seconds to wait for worker (default: Inf)}

\item{max_calls_worker}{Maxmimum number of function calls that will be sent to one worker}

\item{verbose}{Print progress messages}
}
\value{
A list of whatever `fun` returned
}
\description{
exchanging messages between the master and workers works the following way:
 * we have submitted a job where we don't know when it will start up
 * it starts, sends is a message list(id=0) indicating it is ready
 * we send it the function definition and common data
   * we also send it the first data set to work on
 * when we get any id > 0, it is a result that we store
   * and send the next data set/index to work on
 * when computatons are complete, we send id=0 to the worker
   * it responds with id=-1 (and usage stats) and shuts down
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Q_rows.r
\name{Q_rows}
\alias{Q_rows}
\title{Queue function calls defined by rows in a data.frame}
\usage{
Q_rows(
  df,
  fun,
  const = list(),
  export = list(),
  pkgs = c(),
  seed = 128965,
  memory = NULL,
  template = list(),
  n_jobs = NULL,
  job_size = NULL,
  rettype = "list",
  fail_on_error = TRUE,
  workers = NULL,
  log_worker = FALSE,
  chunk_size = NA,
  timeout = Inf,
  max_calls_worker = Inf,
  verbose = TRUE
)
}
\arguments{
\item{df}{data.frame with iterated arguments}

\item{fun}{A function to call}

\item{const}{A list of constant arguments passed to each function call}

\item{export}{List of objects to be exported to the worker}

\item{pkgs}{Character vector of packages to load on the worker}

\item{seed}{A seed to set for each function call}

\item{memory}{Short for `template=list(memory=value)`}

\item{template}{A named list of values to fill in the scheduler template}

\item{n_jobs}{The number of jobs to submit; upper limit of jobs if job_size
is given as well}

\item{job_size}{The number of function calls per job}

\item{rettype}{Return type of function call (vector type or 'list')}

\item{fail_on_error}{If an error occurs on the workers, continue or fail?}

\item{workers}{Optional instance of QSys representing a worker pool}

\item{log_worker}{Write a log file for each worker}

\item{chunk_size}{Number of function calls to chunk together
defaults to 100 chunks per worker or max. 10 kb per chunk}

\item{timeout}{Maximum time in seconds to wait for worker (default: Inf)}

\item{max_calls_worker}{Maxmimum number of chunks that will be sent to one worker}

\item{verbose}{Print status messages and progress bar (default: TRUE)}
}
\description{
Queue function calls defined by rows in a data.frame
}
\examples{
\dontrun{
# Run a simple multiplication for data frame columns x and y on a worker node
fx = function (x, y) x * y
df = data.frame(x = 5, y = 10)
Q_rows(df, fx, job_size = 1)
# [1] 50

# Q_rows also matches the names of a data frame with the function arguments
fx = function (x, y) x - y
df = data.frame(y = 5, x = 10)
Q_rows(df, fx, job_size = 1)
# [1] 5
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qsys_lsf.r
\name{LSF}
\alias{LSF}
\title{LSF scheduler functions}
\description{
Derives from QSys to provide LSF-specific functions
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qsys_slurm.r
\name{SLURM}
\alias{SLURM}
\title{SLURM scheduler functions}
\description{
Derives from QSys to provide SLURM-specific functions
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qsys_sge.r
\name{GCS}
\alias{GCS}
\title{Class for Gridware Cluster Scheduler (GCS)}
\description{
Class for Gridware Cluster Scheduler (GCS)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workers.r
\name{workers}
\alias{workers}
\title{Creates a pool of workers}
\usage{
workers(
  n_jobs,
  data = NULL,
  reuse = TRUE,
  template = list(),
  log_worker = FALSE,
  qsys_id = getOption("clustermq.scheduler", qsys_default),
  verbose = FALSE,
  ...
)
}
\arguments{
\item{n_jobs}{Number of jobs to submit (0 implies local processing)}

\item{data}{Set common data (function, constant args, seed)}

\item{reuse}{Whether workers are reusable or get shut down after call}

\item{template}{A named list of values to fill in template}

\item{log_worker}{Write a log file for each worker}

\item{qsys_id}{Character string of QSys class to use}

\item{verbose}{Print message about worker startup}

\item{...}{Additional arguments passed to the qsys constructor}
}
\value{
An instance of the QSys class
}
\description{
Creates a pool of workers
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Q.r
\name{Q}
\alias{Q}
\title{Queue function calls on the cluster}
\usage{
Q(
  fun,
  ...,
  const = list(),
  export = list(),
  pkgs = c(),
  seed = 128965,
  memory = NULL,
  template = list(),
  n_jobs = NULL,
  job_size = NULL,
  rettype = "list",
  fail_on_error = TRUE,
  workers = NULL,
  log_worker = FALSE,
  chunk_size = NA,
  timeout = Inf,
  max_calls_worker = Inf,
  verbose = TRUE
)
}
\arguments{
\item{fun}{A function to call}

\item{...}{Objects to be iterated in each function call}

\item{const}{A list of constant arguments passed to each function call}

\item{export}{List of objects to be exported to the worker}

\item{pkgs}{Character vector of packages to load on the worker}

\item{seed}{A seed to set for each function call}

\item{memory}{Short for `template=list(memory=value)`}

\item{template}{A named list of values to fill in the scheduler template}

\item{n_jobs}{The number of jobs to submit; upper limit of jobs if job_size
is given as well}

\item{job_size}{The number of function calls per job}

\item{rettype}{Return type of function call (vector type or 'list')}

\item{fail_on_error}{If an error occurs on the workers, continue or fail?}

\item{workers}{Optional instance of QSys representing a worker pool}

\item{log_worker}{Write a log file for each worker}

\item{chunk_size}{Number of function calls to chunk together
defaults to 100 chunks per worker or max. 10 kb per chunk}

\item{timeout}{Maximum time in seconds to wait for worker (default: Inf)}

\item{max_calls_worker}{Maxmimum number of chunks that will be sent to one worker}

\item{verbose}{Print status messages and progress bar (default: TRUE)}
}
\value{
A list of whatever `fun` returned
}
\description{
Queue function calls on the cluster
}
\examples{
\dontrun{
# Run a simple multiplication for numbers 1 to 3 on a worker node
fx = function(x) x * 2
Q(fx, x=1:3, n_jobs=1)
# list(2,4,6)

# Run a mutate() call in dplyr on a worker node
iris \%>\%
    mutate(area = Q(`*`, e1=Sepal.Length, e2=Sepal.Width, n_jobs=1))
# iris with an additional column 'area'
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clustermq-package.r
\docType{package}
\name{clustermq-package}
\alias{clustermq}
\alias{clustermq-package}
\title{Evaluate Function Calls on HPC Schedulers (LSF, SGE, GCS, OCS, SLURM)}
\description{
Provides the \code{Q} function to send arbitrary function calls to
workers on HPC schedulers without relying on network-mounted storage.
Allows using remote schedulers via SSH.
}
\details{
Under the hood, this will submit a cluster job that connects to the master
via TCP the master will then send the function and argument chunks to the
worker and the worker will return the results to the master until everything
is done and you get back your result

Computations are done entirely on the network and without any temporary
files on network-mounted storage, so there is no strain on the file system
apart from starting up R once per job. This removes the biggest bottleneck
in distributed computing.

Using this approach, we can easily do load-balancing, i.e. workers that get
their jobs done faster will also receive more function calls to work on. This
is especially useful if not all calls return after the same time, or one
worker has a high load.

For more detailed usage instructions, see the documentation of the \code{Q}
function.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://mschubert.github.io/clustermq/}
  \item Report bugs at \url{https://github.com/mschubert/clustermq/issues}
}

}
\author{
\strong{Maintainer}: Michael Schubert \email{mschu.dev@gmail.com} (\href{https://orcid.org/0000-0002-6862-5221}{ORCID}) [copyright holder]

Authors:
\itemize{
  \item ZeroMQ authors (source files in 'src/libzmq' and 'src/cppzmq') [copyright holder]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qsys_multicore.r
\name{MULTICORE}
\alias{MULTICORE}
\title{Process on multiple cores on one machine}
\description{
Derives from QSys to provide multicore-specific functions
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qsys_local.r
\name{LOCAL}
\alias{LOCAL}
\title{Placeholder for local processing}
\description{
Mainly so tests pass without setting up a scheduler
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qsys_sge.r
\name{SGE}
\alias{SGE}
\title{SGE scheduler functions}
\description{
Derives from QSys to provide SGE-specific functions
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/zzz.r
\name{.onAttach}
\alias{.onAttach}
\title{Report queueing system on package attach if not set}
\usage{
.onAttach(libname, pkgname)
}
\arguments{
\item{libname}{default arg for compatibility}

\item{pkgname}{default arg for compatibility}
}
\description{
Report queueing system on package attach if not set
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util.r
\docType{data}
\name{vec_lookup}
\alias{vec_lookup}
\title{Lookup table for return types to vector NAs}
\format{
An object of class \code{list} of length 9.
}
\usage{
vec_lookup
}
\description{
Lookup table for return types to vector NAs
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_args.r
\name{check_args}
\alias{check_args}
\title{Function to check arguments with which Q() is called}
\usage{
check_args(fun, iter, const = list())
}
\arguments{
\item{fun}{A function to call}

\item{iter}{Objects to be iterated in each function call}

\item{const}{A list of constant arguments passed to each function call}
}
\value{
Processed iterated argument list if 'iter' is a list
}
\description{
Function to check arguments with which Q() is called
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util.r
\name{host}
\alias{host}
\title{Construct the ZeroMQ host address}
\usage{
host(
  node = getOption("clustermq.host", Sys.info()["nodename"]),
  ports = getOption("clustermq.ports", 6000:9999),
  n = 100
)
}
\arguments{
\item{node}{Node or device name}

\item{ports}{Range of ports to consider}

\item{n}{How many addresses to return}
}
\value{
The possible addresses as character vector
}
\description{
Construct the ZeroMQ host address
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util.r
\name{wrap_error}
\alias{wrap_error}
\title{Wraps an error in a condition object}
\usage{
wrap_error(call)
}
\description{
Wraps an error in a condition object
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summarize_result.r
\name{summarize_result}
\alias{summarize_result}
\title{Print a summary of errors and warnings that occurred during processing}
\usage{
summarize_result(
  result,
  n_errors,
  n_warnings,
  cond_msgs,
  at = length(result),
  fail_on_error = TRUE
)
}
\arguments{
\item{result}{A list or vector of the processing result}

\item{n_errors}{How many errors occurred}

\item{n_warnings}{How many warnings occurred}

\item{cond_msgs}{Error and warnings messages, we display first 50}

\item{at}{How many calls were procesed  up to this point}

\item{fail_on_error}{Stop if error(s) occurred}
}
\description{
Print a summary of errors and warnings that occurred during processing
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qsys_ssh.r
\name{SSH}
\alias{SSH}
\title{SSH scheduler functions}
\description{
Derives from QSys to provide SSH-specific functions
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/worker.r
\name{worker}
\alias{worker}
\title{R worker submitted as cluster job}
\usage{
worker(master, ..., verbose = TRUE, context = NULL)
}
\arguments{
\item{master}{The master address (tcp://ip:port)}

\item{...}{Catch-all to not break older template values (ignored)}

\item{verbose}{Whether to print debug messages}

\item{context}{ZeroMQ context (for internal testing)}
}
\description{
Do not call this manually, the master will do that
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qsys_sge.r
\name{OCS}
\alias{OCS}
\title{Class for Open Cluster Scheduler (OCS)}
\description{
Class for Open Cluster Scheduler (OCS)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/zzz.r
\name{.onLoad}
\alias{.onLoad}
\title{Select the queueing system on package loading}
\usage{
.onLoad(libname, pkgname)
}
\arguments{
\item{libname}{default arg for compatibility}

\item{pkgname}{default arg for compatibility}
}
\description{
This is done by setting the variable 'qsys' in the package environment
to the object that contains the desired queueing system.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ssh_proxy.r
\name{ssh_proxy}
\alias{ssh_proxy}
\title{SSH proxy for different schedulers}
\usage{
ssh_proxy(fwd_port, qsys_id = qsys_default)
}
\arguments{
\item{fwd_port}{The port of the master address to connect to
(remote end of reverse tunnel)}

\item{qsys_id}{Character string of QSys class to use}
}
\description{
Do not call this manually, the SSH qsys will do that
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util.r
\name{fill_template}
\alias{fill_template}
\title{Fill a template string with supplied values}
\usage{
fill_template(template, values, required = c())
}
\arguments{
\item{template}{A character string of a submission template}

\item{values}{A named list of key-value pairs}

\item{required}{Keys that must be present in the template (default: none)}
}
\value{
A template where placeholder fields were replaced by values
}
\description{
Fill a template string with supplied values
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/foreach.r
\name{cmq_foreach}
\alias{cmq_foreach}
\title{clustermq foreach handler}
\usage{
cmq_foreach(obj, expr, envir, data)
}
\arguments{
\item{obj}{Returned from foreach::foreach, containing the following variables:
args    : Arguments passed, each as a call
argnames: character vector of arguments passed
evalenv : Environment where to evaluate the arguments
export  : character vector of variable names to export to nodes
packages: character vector of required packages
verbose : whether to print status messages [logical]
errorHandling: string of function name to call error with, e.g. "stop"}

\item{expr}{An R expression in curly braces}

\item{envir}{Environment where to evaluate the arguments}

\item{data}{Common arguments passed by register_dopcar_cmq(), e.g. n_jobs}
}
\description{
clustermq foreach handler
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/work_chunk.r
\name{work_chunk}
\alias{work_chunk}
\title{Function to process a chunk of calls}
\usage{
work_chunk(
  df,
  fun,
  const = list(),
  rettype = "list",
  common_seed = NULL,
  progress = FALSE
)
}
\arguments{
\item{df}{A data.frame with call IDs as rownames and arguments as columns}

\item{fun}{The function to call}

\item{const}{Constant arguments passed to each call}

\item{rettype}{Return type of function}

\item{common_seed}{A seed offset common to all function calls}

\item{progress}{Logical indicated whether to display a progress bar}
}
\value{
A list of call results (or try-error if they failed)
}
\description{
Each chunk comes encapsulated in a data.frame
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pool.r
\name{Pool}
\alias{Pool}
\title{Class for basic queuing system functions}
\description{
Provides the basic functions needed to communicate between machines
This should abstract most functions of rZMQ so the scheduler
implementations can rely on the higher level functionality
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/foreach.r
\name{register_dopar_cmq}
\alias{register_dopar_cmq}
\title{Register clustermq as `foreach` parallel handler}
\usage{
register_dopar_cmq(...)
}
\arguments{
\item{...}{List of arguments passed to the `Q` function, e.g. n_jobs}
}
\description{
Register clustermq as `foreach` parallel handler
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qsys_multiprocess.r
\name{MULTIPROCESS}
\alias{MULTIPROCESS}
\title{Process on multiple processes on one machine}
\description{
Derives from QSys to provide callr-specific functions
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chunk.r
\name{chunk}
\alias{chunk}
\title{Subset index chunk for processing}
\usage{
chunk(x, i)
}
\arguments{
\item{x}{Index data.frame}

\item{i}{Rows to subset}
}
\value{
x[i,]
}
\description{
'attr' in `[.data.frame` takes too much CPU time
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/util.r
\name{msg_fmt}
\alias{msg_fmt}
\title{Message format for logging}
\usage{
msg_fmt(verbose = TRUE)
}
\description{
Message format for logging
}
\keyword{internal}
